%A200628AnalysisONEY
 %% USER OPTIONS
%  dataselectind=36;
% datatype=otervars(dataselectind,2); %1=path headings, 2=Extrema+Plateaux, 3=Extrema, 4=Plateaux
% varfoodorpattern=otervars(dataselectind,1); %Food=1; Pattern=2 - Is plotted angle data relative to the food orbthe pattern on the cylinder?
% turndirection=otervars(dataselectind,3); %LEFT=0; RIGHT=1; BOTH=3
% turnstartregion=streg{dataselectind}; %Deg
% testtype=otervars(dataselectind,4); %0=training, 1= Test1 etc 

datatype=1; %1=path headings, 2=Extrema+Plateaux, 3=Extrema, 4=Plateaux
varfoodorpattern=1; %Food=1; Pattern=2 - Is plotted angle data relative to the food orbthe pattern on the cylinder?
turndirection=3; %LEFT=0; RIGHT=1; BOTH=3
turnstartregion=[]; %Deg
testtype=1; %0=training, 1= Test1 etc 
%%
refinedataset=1; %0=Use dataset currently in workspace (use if you have generated a dataset and want to keep on using it for further analysis); 1=use parameters in the rest of 'Define dataset' section to select a new dataset
perant=1; %0=use each individual datapoint, 1=use median datapoint for each individual ant, 2=use median datapoint for each path
    %NB whether mean or median used is determined by 'avetype'  below
avetype=1; %What measure of average to plot on histogram: 1=mean, 2=median

 %%
 
 %Define dataset
% datadescription='Combined Extrema+Plateaux; end points of RIGHT turns begining 30 degrees to either side of pattern; 1 datapoint per ant (circular  median of all turns made by that ant)';
savedir='D:\Dropbox\ONEYE analysis for Tom\200515 Platdur 0p20 flips corrected\200524 Analysis and figures\201103 Analysis and figure testing';
% datatype=1; %1=path headings, 2=Extrema+Plateaux, 3=Extrema, 4=Plateaux
% varfoodorpattern=1; %Food=1; Pattern=2 - Is plotted angle data relative to the food orbthe pattern on the cylinder?
choosestartorend=3; %For choosing which turns to look at. 1= use starting position of each turn. 2=use end-point of each turn. 3=use mean heading of path
startfoodorpattern=2; %Food=1; Pattern=2 - When choosing turns that start facing a certain regions, do we mean relative to the food or the pattern on the cylinder?
% turndirection=0; %LEFT=0; RIGHT=1; BOTH=3
maxdist=45; %cm
turnselectiontype=2; %1=left boundary relative to left edge of pattern, right boundary relative to right edge of pattern; 2=left and right boundaries used as given (e.g. both relative to 0, aka both relative to channel-matching prediction); 3=left and right boundary calculated relative to pattern-matching prediction; 4=left and right boundary calclulated relative to center of mass of pattern
% turnstartregion=[20 -20]; %Deg
% turnstartregion=[39.5493 -39.5493]; %Deg
% turnstartregion=[13.369+20 13.369-20]; %Deg
% turnstartregion=[]; %Deg
headselectiontype=2; %1=left boundary relative to left edge of pattern, right boundary relative to right edge of pattern; 2=left and right boundaries used as given (e.g. both relative to 0, aka both relative to channel-matching prediction); 3=left and right boundary calculated relative to pattern-matching prediction; 4=left and right boundary calclulated relative to center of mass of pattern
headstartregion=[]; %if chooseheading=[], we just select data on the basis of what we specify with 'turnstartregion' etc. If a 1*2 vector entered here, we choose turns by 'turnstartregion' AND by heading: overall path heading must be within the specified range. If a 2*2 vector entered here, the top 1*2 number speicify the heading region for test data dntbhe lower 1*2 numbers specify the heading region  for training data. 
% headstartregion=[20 -20]; %if chooseheading=[], we just select data on the basis of what we specify with 'turnstartregion' etc. If a 1*2 vector entered here, we choose turns by 'turnstartregion' AND by heading: overall path heading must be within the specified range. If a 2*2 vector entered here, the top 1*2 number speicify the heading region for test data dntbhe lower 1*2 numbers specify the heading region  for training data. 
minconsistency=0.4; %only pick runs/turns by ants whose total runs were at least this consistent
mintestsbyant=1; %only pick runs/turns by ants that did more than this no tests over the whole exepriments
%Use all training data or only runs preceding test
traintype=1;  %0=all training, 1=pretest training only
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Analysis choices
    %NB whether mean or median used is determined by 'avetype'  below
linearmed=0; %0=use circular median, 1=use linearised median
whatdata=1; %1=ONEY one-eyed ants; 2=RSS0 binocular ants
weirdleftthing=0; %1= if we have selected only left turns, we copare them to the bar position and not to the expected goal direction.  0=we treat leeft and roght turns the same
%What tests to perform: 1 column per experimental run  type; 1 row per
%statistical test. 1=run test; 0=do not run test
%             %All paths/turns                  | Selected turns in onedirection | ONEY experiments
%             %Training,  Test1,  Test2,  Test3 | Training,   Test1,  Test2,  Test3
% runtests=  [1           1       1       1       1           1       1       0;... %1: R-test: is distribution uniform around the circle
%             1           1       1       1       1           0       0       0;... %2: circ_medtest, H0=0: is median of distribution different to 0 (channel matching prediction)
%             0           1       1       0       0           1       1       0;... %3: circ_medtest, H0=pattern-match: is mean of distribution different to pattern-matching prediction
%             1           1       1       1       1           0       0       0;... %4: circ_mtest,H0=0: is mean of distribution different to 0 (channel matching prediction)
%             0           1       1       0       0           1       1       0;... %5: circ_mtest, H0=pattern-match: is mean of distribution different to pattern-matching prediction
%             0           1       1       1       0           0       0       0;... %6: circ_cmtest, Test vs Train: is median of test distribution different to unrotated training data (i.e. do they match on the channel prediction?)
%             0           1       1       0       0           1       1       0;... %7: circ_cmtest, Test vs rotated Train: is median of test distribution different to training data after it has been rotated to match the pattern-prediction (i.e. do they match on the pattern prediction?)
%             0           1       1       1       0           0       0       0;... %8: circ_wwtest, Test vs Train: is mean of test distribution different to unrotated training data (i.e. do they match on the channel prediction?)
%             0           1       1       0       0           1       1       0;... %9: circ_wwtest, Test vs rotated Train: is mean of test distribution different to training data after it has been rotated to match the pattern-prediction (i.e. do they match on the pattern prediction?)
%             0           1       1       1       0           1       1       0;... %10: circ_ktest, Test vs rotated Train: is 'concentration parameter' different between  test and training distributions (i.e. is one more concentrated/dispersed than the other?)
%             0           1       1       1       0           0       0       0;... %11: signrank, Test vs Train: paired Wilcoxon sign rank test, is difference between each ant's median test angle vs the same ant's training data equal to zero? A paired equivalent of test 6: do they match on the channel prediction? (NB: only works if perant==1)
%             0           1       1       0       0           1       1       0;... %12: signrank, Test vs rotated Train: paired Wilcoxon sign rank test, is difference between each ant's median test angle vs the same ant's training data equal to zero? A paired equivalent of test 7: do they match on the pattern prediction? (NB: only works if perant==1)
%             ];

            %All paths/turns                  | Selected turns in onedirection | RSS0 experiments
            %Training,  Test1,  Test2,  Test3 | Training,   Test1,  Test2,  Test3
runtests=  [1           1       1       1       1           1       1       0;... %1: R-test: is distribution uniform around the circle
            0           0       0       0       0           0       0       0;... %2: circ_medtest, H0=0: is median of distribution different to 0 (channel matching prediction)
            0           0       0       0       0           0       0       0;... %3: circ_medtest, H0=pattern-match: is mean of distribution different to pattern-matching prediction
            1           1       1       1       1           1       1       0;... %4: circ_mtest,H0=0: is mean of distribution different to 0 (channel matching prediction)
            0           1       1       0       0           1       1       0;... %5: circ_mtest, H0=pattern-match: is mean of distribution different to pattern-matching prediction
            0           0       0       0       0           0       0       0;... %6: circ_cmtest, Test vs Train: is median of test distribution different to unrotated training data (i.e. do they match on the channel prediction?)
            0           0       0       0       0           0       0       0;... %7: circ_cmtest, Test vs rotated Train: is median of test distribution different to training data after it has been rotated to match the pattern-prediction (i.e. do they match on the pattern prediction?)
            0           1       1       1       0           1       1       0;... %8: circ_wwtest, Test vs Train: is mean of test distribution different to unrotated training data (i.e. do they match on the channel prediction?)
            0           1       1       0       0           1       1       0;... %9: circ_wwtest, Test vs rotated Train: is mean of test distribution different to training data after it has been rotated to match the pattern-prediction (i.e. do they match on the pattern prediction?)
            0           1       1       1       0           1       1       0;... %10: circ_ktest, Test vs rotated Train: is 'concentration parameter' different between  test and training distributions (i.e. is one more concentrated/dispersed than the other?)
            0           0       0       0       0           0       0       0;... %11: signrank, Test vs Train: paired Wilcoxon sign rank test, is difference between each ant's median test angle vs the same ant's training data equal to zero? A paired equivalent of test 6: do they match on the channel prediction? (NB: only works if perant==1)
            0           0       0       0       0           0       0       0;... %12: signrank, Test vs rotated Train: paired Wilcoxon sign rank test, is difference between each ant's median test angle vs the same ant's training data equal to zero? A paired equivalent of test 7: do they match on the pattern prediction? (NB: only works if perant==1)
            1           1       1       1       1           1       1       0;... %13: circ_vtest, H0=0: is distirubution non-uniform with mean = 0 (channel matching prediction)
            0           1       1       0       0           1       1       0;... %14: circ_vtest, H0=0: is distirubution non-uniform with mean = pattern matching prediction
            0           1       1       1       0           1       1       0;... %15: mardiatestn_circ_equal, Test vs Train: is test data drawn from same distirubtion as unrotated training data (i.e. do they match on the channel prediction?)
            0           1       1       0       0           1       1       0;... %16: mardiatestn_circ_equal, Test vs rotated  Train: is test data drawn from same distirubtion as training data after it has been rotated to match the pattern-prediction (i.e. do they match on the pattern prediction?)
            0           1       1       1       0           0       0       0;... %17: 2-sample t-test of sinuosity, Test vs Train: H0=test paths are equally sinuous as training paths
            0           1       1       1       0           0       0       0;... %18: paired t-test of sinuosity, Test vs Train: H0=test paths of each ant are equally sinuous as training paths (NB: only works if perant==1)
            1           1       1       1       1           1       1       0;... %19: HartigansDipSignifTest, H0=test data is drawn from unimodal distribution
            1           1       1       1       1           1       1       0;... %20: Make fig showing propn end-points from each bin of start-points that end up facing goal
            1           1       1       1       1           1       1       0;... %21: Make fig showing correlation end-points vs headings
            0           0       0       0       0           0       0       0;... %22: Make fig showing discrepancy between end-point and goal, violin, L vs R
            0           0       0       0       0           0       0       0;... %23: Make fig showing discrepancy between end-point and goal, violin, binned by discrepancy between path dir and goal
            0           0       0       0       0           0       0       0;... %24: Make fig showing size of turn, violin, binned by discrepancy between path dir and goal
            0           0       0       0       0           0       0       0;... %25: Make fig showing size of turn, violin, binned by discrepancy between path dir and end-point
            0           0       0       0       0           0       0       0;... %26: Make histogram showing end-points relative to headings (i.e. 0 = turn ended facing heading
            1           1       1       1       1           1       1       0;... %27: circ_corrcc test for correlation between end-points and headings
            1           1       1       1       1           1       1       0;... %28: circ_mtest, end point-heading, H0=0: is mean discrepancy between end-pint and overall path heading equal to 0 (i.e. do end points face overall  path headings)
            1           1       1       1       1           1       1       0;... %29: circ_vtest, end point-heading, H0=0: is mean discrepancy between end-pint and overall path heading equal to 0 (i.e. do end points face overall  path headings)
            1           1       1       1       1           1       1       0;... %30: Likeliood ratio test,H0=0: is mean of distribution different to 0 (channel matching prediction)
            0           1       1       0       0           1       1       0;... %31: Likeliood ratio test, H0=pattern-match: is mean of distribution different to pattern-matching prediction
            1           1       1       1       1           1       1       0;... %32: Watson-Williams mean test,H0=0: is mean of distribution different to 0 (channel matching prediction)
            0           1       1       0       0           1       1       0;... %33: Watson-Williams mean test, H0=pattern-match: is mean of distribution different to pattern-matching prediction
            1           1       1       1       1           1       1       0;... %34: Likeliood ratio test, endpoint-heading, H0=0: is mean discrepancy between end-pint and overall path heading equal to 0 (i.e. do end points face overall  path headings)
            1           1       1       1       1           1       1       0;... %35: Watson-Wiliams mean test, endpoint-heading, H0=0: is mean discrepancy between end-pint and overall path heading equal to 0 (i.e. do end points face overall  path headings)
            ];        
        
        
%Histogram plotting choices
plothist=1;  %0=don't make figure; 1=make histogram figure

%% Other inputs
%ONEY pattern data
%Get patterndata
if whatdata==1
    patternpath={'D:\Dropbox\Documents\1208 Sussex Ant Postdoc\180305 ONEYE\XXPatterns\ONEY Training Pattern.mat'...
                    'D:\Dropbox\Documents\1208 Sussex Ant Postdoc\180305 ONEYE\XXPatterns\ONEY 1Tst Pattern.mat'...
                    'D:\Dropbox\Documents\1208 Sussex Ant Postdoc\180305 ONEYE\XXPatterns\ONEY 2Tst Pattern.mat'...
                    'D:\Dropbox\Documents\1208 Sussex Ant Postdoc\180305 ONEYE\XXPatterns\ONEY 3Tst Pattern.mat'...
                    };
   pledge=zeros(length(patternpath),1)    ;
   predge=zeros(length(patternpath),1)    ;
 for testind=0:3               
    load(patternpath{testind+1});
    if isempty(patternledge)==0
    pledge(testind+1)=patternledge;
    else
    pledge(testind+1)=NaN;
    end
    if isempty(patternredge)==0
    predge(testind+1)=patternredge;
    else
    predge(testind+1)=NaN;
    end
 end
pledge=[pledge;NaN];
predge=[predge;NaN];
elseif whatdata==2
% %RSS0 patterndata
pledge=[50;...
        70;...
        110];
predge=[30;...
        30;...
        30];
end %if whatdata
 
% Options for histograms
%settings
%     options.binsize=5; %5deg bins used on original paper submission
%     options.binsize=[5 8 10 12 15];
    options.binsize=[12];
    options.bootstrapn=10000;
    options.medianprecision=0.01;
    options.mediantype=1;
    options.drawatvisres=0;
    options.patternfigheight=0;
if whatdata==1    
    predictions.edgematches=[0; 45; -41.1803; 0; 0]; %ONEY experiments
elseif whatdata==2
    predictions.edgematches=[0; 10; 30]; %RSS0 experiments: note these are actually CoM matching predictions
    predictions.lmatches=[0; 20; 60]; %RSS0 experiments: predictions if ants matched the left edge of the pattern
end %if whatdata
    options.whatci=2;
    options.plotcom=0;
    options.plotfpm=0;
    options.plothybrid=0;
    options.plotedgematch=1;
    options.plotkernel=0;
    options.quantilerange=0.5;
    options.IQRtype=1;
    
    dist=150;




%%
%choose variables
if refinedataset==1
    if datatype==1
        if varfoodorpattern==1
            BDependentVariable=ARMeandirFortyFive60;
        else
            BDependentVariable=ARMeandirFortyFive150;    
        end
        if varfoodorpattern==1
            BHeading=ARMeandirFortyFive60;
        else
            BHeading=ARMeandirFortyFive150;    
        end
        if startfoodorpattern==1
           BStartVar=ARMeandirFortyFive60;
        else
           BStartVar=ARMeandirFortyFive150;
        end
        if varfoodorpattern==1
           BSinuosity=ARdistratio;
        else
%            BSinuosity=ARVeclengthFortyFive150;
             BSinuosity=ARdistratio;

        end
            BTurnType=3*ones(size(BDependentVariable));
            BTestType=ARTestType;
            BSupersededFlag=ARSupersededFlag;
            BPreTestFlag=ARPreTestFlag;
            BAntIDNo=ARAntIDNo;
            BRunNo=ARRunNo;
            BInMainPathFlag=ones(size(BDependentVariable));
            BTurnDirection=3*ones(size(BDependentVariable));
            BTurnAmplitude=zeros(size(BDependentVariable));
            BTestsByAnt=ARTestsByAnt;
            BHeadingConsistency=ARHeadingConsistencyFood;
            BTurnDist=zeros(size(BDependentVariable));
    elseif datatype==2
        if varfoodorpattern==1
            BDependentVariable=[APplateauendfacefood; AWwiggleendfacefood];
            BTurnType=[ones(size(APplateauendfacefood)); 2*ones(size(AWwiggleendfacefood))];
        else
            BDependentVariable=[APplateauendfacepattern; AWwiggleendfacepattern]; 
            BTurnType=[ones(size(APplateauendfacepattern)); 2*ones(size(AWwiggleendfacepattern))];
        end
        if varfoodorpattern==1
            BHeading=[APMeandirFortyFive60; AWMeandirFortyFive60];
        else
            BHeading=[APMeandirFortyFive150; AWMeandirFortyFive150];    
        end
        if startfoodorpattern==1
            BStartVar=[APplateaustartfacefood; AWwigglestartfacefood];
        else
            BStartVar=[APplateaustartfacepattern; AWwigglestartfacepattern]; 
        end
           BSinuosity=zeros(size(BDependentVariable)); %it  only makes sens to look at sinuosity on the level of whole paths. for any other type of analysis, we just make a dummy variable of zeros

            BTestType=[APTestType; AWTestType];
            BSupersededFlag=[APSupersededFlag; AWSupersededFlag];
            BPreTestFlag=[APPreTestFlag; AWPreTestFlag];
            BAntIDNo=[APAntIDNo; AWAntIDNo];
            BRunNo=[APRunNo; AWRunNo];
            BInMainPathFlag=[APinmainpathflag; AWinmainpathflag];
            BTurnDirection=[APplateauturndirection; AWwiggledirection];
            BTurnAmplitude=[APplateauturnamplitude; AWwiggleamplitude];
            BTestsByAnt=[APTestsByAnt; AWTestsByAnt];
            BHeadingConsistency=[APHeadingConsistencyFood; AWHeadingConsistencyFood];
            BTurnDist=[APplateauendr; AWwiggleendr];
    elseif datatype==3
        if varfoodorpattern==1
            BDependentVariable=AWwiggleendfacefood;
        else
            BDependentVariable=AWwiggleendfacepattern;    
        end
        if varfoodorpattern==1
            BHeading=AWMeandirFortyFive60;
        else
            BHeading=AWMeandirFortyFive150;    
        end
        if startfoodorpattern==1
            BStartVar=AWwigglestartfacefood;
        else
            BStartVar=AWwigglestartfacepattern;
        end
        BTurnType=2*ones(size(BDependentVariable));
            BSinuosity=zeros(size(BDependentVariable)); %it  only makes sens to look at sinuosity on the level of whole paths. for any other type of analysis, we just make a dummy variable of zeros

            BTestType=AWTestType;
            BSupersededFlag=AWSupersededFlag;
            BPreTestFlag=AWPreTestFlag;
            BAntIDNo=AWAntIDNo;
            BRunNo=AWRunNo;
            BInMainPathFlag=AWinmainpathflag;
            BTurnDirection=AWwiggledirection;
            BTurnAmplitude=AWwiggleamplitude;
            BTestsByAnt=AWTestsByAnt;
            BHeadingConsistency=AWHeadingConsistencyFood;
            BTurnDist=AWwiggleendr;
    elseif datatype==4
        if varfoodorpattern==1
            BDependentVariable=APplateauendfacefood;
        else
            BDependentVariable=APplateauendfacepattern;    
        end
        if varfoodorpattern==1
            BHeading=APMeandirFortyFive60;
        else
            BHeading=APMeandirFortyFive150;    
        end
        if startfoodorpattern==1
            BStartVar=APplateaustartfacefood;
        else
            BStartVar=APplateaustartfacepattern;
        end
            BSinuosity=zeros(size(BDependentVariable)); %it  only makes sens to look at sinuosity on the level of whole paths. for any other type of analysis, we just make a dummy variable of zeros
            BTurnType=ones(size(BDependentVariable));
            BTestType=APTestType;
            BSupersededFlag=APSupersededFlag;
            BPreTestFlag=APPreTestFlag;
            BAntIDNo=APAntIDNo; 
            BRunNo=APRunNo;
            BInMainPathFlag=APinmainpathflag;
            BTurnDirection=APplateauturndirection;
            BTurnAmplitude=APplateauturnamplitude;
            BTestsByAnt=APTestsByAnt;
            BHeadingConsistency=APHeadingConsistencyFood;
            BTurnDist=APplateauendr;
    end %if datatype==1
  %%  
    %If necessary, work out which turns start in correct region
    if isempty(turnstartregion)==1
        BStartPosition=ones(size(BDependentVariable));
    else
        if choosestartorend==1
            selectvar=BStartVar;
        elseif choosestartorend==2
            selectvar=BDependentVariable;
        elseif choosestartorend==3
            selectvar=BHeading;
        end

        BStartPosition=zeros(size(BDependentVariable));
        for bind=1:length(BDependentVariable)
            %Work out candidate region for turn starts
            if turnselectiontype==1
                turnregionleft=(pledge(BTestType(bind)+1)+turnstartregion(1));
                turnregionright=(predge(BTestType(bind)+1)+turnstartregion(2));
            elseif turnselectiontype==2
                turnregionleft=turnstartregion(1);
                turnregionright=turnstartregion(2);
            elseif turnselectiontype==3
                turnregionleft=(predictions.edgematches(BTestType(bind)+1)+turnstartregion(1));
                turnregionright=(predictions.edgematches(BTestType(bind)+1)+turnstartregion(2));
            elseif turnselectiontype==4
                    patterncenter=((pledge(BTestType(bind)+1)-predge(BTestType(bind)+1))/2)+predge(BTestType(bind)+1);
                turnregionleft=(patterncenter+turnstartregion(1));
                turnregionright=(patterncenter+turnstartregion(2));
            end %if turnselectiontype==1
            
            %If necessary, also select by overall heading
            if isempty(headstartregion)==1
                headregionleft=3600;
                headregionright=-3600;
            else
                if headselectiontype==1
                    headregionleft=(pledge(BTestType(bind)+1)+headstartregion(1));
                    headregionright=(predge(BTestType(bind)+1)+headstartregion(2));
                elseif headselectiontype==2
                    headregionleft=headstartregion(1);
                    headregionright=headstartregion(2);
                elseif headselectiontype==3
                    headregionleft=(predictions.edgematches(BTestType(bind)+1)+headstartregion(1));
                    headregionright=(predictions.edgematches(BTestType(bind)+1)+headstartregion(2));
                elseif headselectiontype==4
                        patterncenter=((pledge(BTestType(bind)+1)-predge(BTestType(bind)+1))/2)+predge(BTestType(bind)+1);
                    headregionleft=(patterncenter+headstartregion(1));
                    headregionright=(patterncenter+headstartregion(2));
                end %if headselectiontype==1
            end %if isempty(headstartregion)==1
            
            %Flag if turn starts in candidate region
           if BTestType(bind)~=3 & BTestType(bind)~=4 & selectvar(bind)<=turnregionleft  & selectvar(bind)>=turnregionright & BHeading(bind)<=headregionleft & BHeading(bind)>=headregionright
               BStartPosition(bind)=1;
           end
        end
    end %if isempty(turnstartregion)==1
%     %Plot selected turn starts to ensure script is working; comment in
%     %normal use
%         patternfigheight= 375;
%         patternfigwidth= 675;           
%         figposition=[9 160 patternfigwidth   patternfigheight];
%         figtitle=[];
%         for qtind=1:3
%         figcreatorhistv200530(BStartVar(BStartPosition==1 & BTestType==qtind-1),hbins.h,xmin,xmax,figposition,[], [], predge(qtind), pledge(qtind), predictions.edgematches(qtind), 0)  ;
%         end

    
    
    
    BSelectedAnt=BTestsByAnt>=mintestsbyant & BHeadingConsistency>minconsistency;
    if whatdata==1
    BBlacklist=(BAntIDNo==29 & BRunNo==55) | (BAntIDNo==31 & BRunNo==49)  | (BAntIDNo==31 & BRunNo==56); %ONEY?
    elseif whatdata==2
    BBlacklist=(BAntIDNo==10 & BRunNo==48); %RSS0?
    else
    BBlacklist=zeros(size(BDependentVariable)); 
    end %if whatdata
    
    BUnderMaxDist=BTurnDist<=maxdist ; 
    if datatype==1 | turndirection==3
        BCorrectTurnDir=ones(size(BDependentVariable));
    else
        BCorrectTurnDir= BTurnDirection==turndirection;
    end
    
%     %Remove any plateaus that are identical to consecutive plateaus:
%     %sometimes the plateau finder splits a single long pause into multiple
%     %plateaus but it's just one incident of the ant looking in the same
%     %place,so we simply remove the extra ones
%     antrunsindataset=unique([BAntIDNo BRunNo], 'rows');
%     for arind=1:length(antrunsindataset)
%         currentturns=find(BAntIDNo==antrunsindataset(arind,1) & BRunNo==antrunsindataset(arind,2));
%         
%     end
%     
    %Select all dps that meet the various criteria for inclusion
    BGoodDP = isnan(BDependentVariable)==0 & BBlacklist==0 & BSelectedAnt==1 & BSupersededFlag==0 & BInMainPathFlag==1 & BCorrectTurnDir==1 & BUnderMaxDist==1 & BStartPosition==1;

    %Refine dataset to keep only the good dps
            BDependentVariable=BDependentVariable(BGoodDP==1);
            BStartVar=BStartVar(BGoodDP==1);
            BHeading=BHeading(BGoodDP==1);
            BSinuosity=BSinuosity(BGoodDP==1);
            BTestType=BTestType(BGoodDP==1);
            BSupersededFlag=BSupersededFlag(BGoodDP==1);
            BPreTestFlag=BPreTestFlag(BGoodDP==1);
            BAntIDNo=BAntIDNo(BGoodDP==1);
            BRunNo=BRunNo(BGoodDP==1);
            BInMainPathFlag=BInMainPathFlag(BGoodDP==1);
            BTurnDirection=BTurnDirection(BGoodDP==1);
            BTurnAmplitude=BTurnAmplitude(BGoodDP==1);
            BTestsByAnt=BTestsByAnt(BGoodDP==1);
            BHeadingConsistency=BHeadingConsistency(BGoodDP==1);
            BTurnDist=BTurnDist(BGoodDP==1);

    % Select appropriate dps for each test type
    BTrainingAllInd= BTestType==0;
    BTrainingPreTestInd= BTestType==0 & BPreTestFlag==1;
    BTest1Ind= BTestType==1 ;
    BTest2Ind= BTestType==2 ;
    BTest3Ind= BTestType==3 ;
    BTrainingAllVar=BDependentVariable(BTrainingAllInd==1);
    BTrainingPreTestVar=BDependentVariable(BTrainingPreTestInd==1);
    BTest1Var=BDependentVariable(BTest1Ind==1);
    BTest2Var=BDependentVariable(BTest2Ind==1);
    BTest3Var=BDependentVariable(BTest3Ind==1);
    BTrainingAllSinuosity=BSinuosity(BTrainingAllInd==1);
    BTrainingPreTestSinuosity=BSinuosity(BTrainingPreTestInd==1);
    BTest1Sinuosity=BSinuosity(BTest1Ind==1);
    BTest2Sinuosity=BSinuosity(BTest2Ind==1);
    BTest3Sinuosity=BSinuosity(BTest3Ind==1);
    BTrainingAllAntIDNo=BAntIDNo(BTrainingAllInd==1);
    BTrainingPreTestAntIDNo=BAntIDNo(BTrainingPreTestInd==1);
    BTest1AntIDNo=BAntIDNo(BTest1Ind==1);
    BTest2AntIDNo=BAntIDNo(BTest2Ind==1);
    BTest3AntIDNo=BAntIDNo(BTest3Ind==1);
    BTrainingAllRunNo=BRunNo(BTrainingAllInd==1);
    BTrainingPreTestRunNo=BRunNo(BTrainingPreTestInd==1);
    BTest1RunNo=BRunNo(BTest1Ind==1);
    BTest2RunNo=BRunNo(BTest2Ind==1);
    BTest3RunNo=BRunNo(BTest3Ind==1);
    BTrainingAllHeading=BHeading(BTrainingAllInd==1);
    BTrainingPreTestHeading=BHeading(BTrainingPreTestInd==1);
    BTest1Heading=BHeading(BTest1Ind==1);
    BTest2Heading=BHeading(BTest2Ind==1);
    BTest3Heading=BHeading(BTest3Ind==1);
    BTrainingAllStartVar=BStartVar(BTrainingAllInd==1);
    BTrainingPreTestStartVar=BStartVar(BTrainingPreTestInd==1);
    BTest1StartVar=BStartVar(BTest1Ind==1);
    BTest2StartVar=BStartVar(BTest2Ind==1);
    BTest3StartVar=BStartVar(BTest3Ind==1);
    BTrainingAllTurnDirection=BTurnDirection(BTrainingAllInd==1);
    BTrainingPreTestTurnDirection=BTurnDirection(BTrainingPreTestInd==1);
    BTest1TurnDirection=BTurnDirection(BTest1Ind==1);
    BTest2TurnDirection=BTurnDirection(BTest2Ind==1);
    BTest3TurnDirection=BTurnDirection(BTest3Ind==1);
    BTrainingAllTurnAmplitude=BTurnAmplitude(BTrainingAllInd==1);
    BTrainingPreTestTurnAmplitude=BTurnAmplitude(BTrainingPreTestInd==1);
    BTest1TurnAmplitude=BTurnAmplitude(BTest1Ind==1);
    BTest2TurnAmplitude=BTurnAmplitude(BTest2Ind==1);
    BTest3TurnAmplitude=BTurnAmplitude(BTest3Ind==1);
    %Get summary Ns (NB, I only use pretest training here. To  use all training
    %instead, change traintype to 0, above)
    B_A=zeros(4,1);
    B_P=zeros(4,1);
    B_E=zeros(4,1);
    if traintype==0
      B_A(1)=length(unique(BAntIDNo(BTestType==0)));
      B_P(1)=length(unique([BAntIDNo(BTestType==0) BRunNo(BTestType==0)], 'rows'));
      B_E(1)=length(BDependentVariable(BTestType==0));
    else
      B_A(1)=length(unique(BAntIDNo(BTestType==0 & BPreTestFlag==1)));
      B_P(1)=length(unique([BAntIDNo(BTestType==0 & BPreTestFlag==1) BRunNo(BTestType==0 & BPreTestFlag==1)], 'rows'));
      B_E(1)=length(BDependentVariable(BTestType==0 & BPreTestFlag==1));
    end
    for tind=1:3
      B_A(tind+1)=length(unique(BAntIDNo(BTestType==tind)));
      B_P(tind+1)=length(unique([BAntIDNo(BTestType==tind) BRunNo(BTestType==tind)], 'rows'));
      B_E(tind+1)=length(BDependentVariable(BTestType==tind));
    end


    %% Work out medians for each ant
    % BTrainingAllVar=BTrainingAllVar(isnan(BTrainingAllVar)==0);
    % BTrainingPreTestVar=BTrainingPreTestVar(isnan(BTrainingPreTestVar)==0);
    % BTest1Var=BTest1Var(isnan(BTest1Var)==0);
    % BTest2Var=BTest2Var(isnan(BTest2Var)==0);
    % BTest2Var=BTest2Var(isnan(BTest2Var)==0);
    
    if avetype==1 %means
        %All training
        CTrainingAllAntIDNo=unique(BTrainingAllAntIDNo);
        CTrainingAllVar=NaN(size(CTrainingAllAntIDNo));
        CTrainingAllSinuosity=NaN(size(CTrainingAllAntIDNo));
        CTrainingAllStartVar=NaN(size(CTrainingAllAntIDNo));
        CTrainingAllTurnAmplitude=NaN(size(CTrainingAllAntIDNo));
        CTrainingAllTurnDirection=NaN(size(CTrainingAllAntIDNo));
        CTrainingAllHeading=NaN(size(CTrainingAllAntIDNo));
        for btind=1:length(CTrainingAllAntIDNo)
            CTrainingAllVar(btind)=rad2ang(circ_mean(ang2rad(BTrainingAllVar(BTrainingAllAntIDNo==CTrainingAllAntIDNo(btind) & isnan(BTrainingAllVar)==0))));
            CTrainingAllSinuosity(btind)=mean(BTrainingAllSinuosity(BTrainingAllAntIDNo==CTrainingAllAntIDNo(btind) & isnan(BTrainingAllSinuosity)==0));
            CTrainingAllStartVar(btind)=rad2ang(circ_mean(ang2rad(BTrainingAllStartVar(BTrainingAllAntIDNo==CTrainingAllAntIDNo(btind) & isnan(BTrainingAllStartVar)==0))));
            CTrainingAllTurnAmplitude(btind)=rad2ang(circ_mean(ang2rad(BTrainingAllTurnAmplitude(BTrainingAllAntIDNo==CTrainingAllAntIDNo(btind) & isnan(BTrainingAllTurnAmplitude)==0))));
            CTrainingAllTurnDirection(btind)=mean(BTrainingAllTurnDirection(BTrainingAllAntIDNo==CTrainingAllAntIDNo(btind) & isnan(BTrainingAllTurnDirection)==0));
            CTrainingAllHeading(btind)=rad2ang(circ_mean(ang2rad(BTrainingAllHeading(BTrainingAllAntIDNo==CTrainingAllAntIDNo(btind) & isnan(BTrainingAllHeading)==0))));
        end

        %Pretest training
        CTrainingPreTestAntIDNo=unique(BTrainingPreTestAntIDNo);
        CTrainingPreTestVar=NaN(size(CTrainingPreTestAntIDNo));
        CTrainingPreTestSinuosity=NaN(size(CTrainingPreTestAntIDNo));
        CTrainingPreTestStartVar=NaN(size(CTrainingPreTestAntIDNo));
        CTrainingPreTestTurnAmplitude=NaN(size(CTrainingPreTestAntIDNo));
        CTrainingPreTestTurnDirection=NaN(size(CTrainingPreTestAntIDNo));
        CTrainingPreTestHeading=NaN(size(CTrainingPreTestAntIDNo));
        for btind=1:length(CTrainingPreTestAntIDNo)
            CTrainingPreTestVar(btind)=rad2ang(circ_mean(ang2rad(BTrainingPreTestVar(BTrainingPreTestAntIDNo==CTrainingPreTestAntIDNo(btind) & isnan(BTrainingPreTestVar)==0))));
            CTrainingPreTestSinuosity(btind)=mean(BTrainingPreTestSinuosity(BTrainingPreTestAntIDNo==CTrainingPreTestAntIDNo(btind) & isnan(BTrainingPreTestSinuosity)==0));
            CTrainingPreTestStartVar(btind)=rad2ang(circ_mean(ang2rad(BTrainingPreTestStartVar(BTrainingPreTestAntIDNo==CTrainingPreTestAntIDNo(btind) & isnan(BTrainingPreTestStartVar)==0))));
            CTrainingPreTestTurnAmplitude(btind)=rad2ang(circ_mean(ang2rad(BTrainingPreTestTurnAmplitude(BTrainingPreTestAntIDNo==CTrainingPreTestAntIDNo(btind) & isnan(BTrainingPreTestTurnAmplitude)==0))));
            CTrainingPreTestTurnDirection(btind)=mean(BTrainingPreTestTurnDirection(BTrainingPreTestAntIDNo==CTrainingPreTestAntIDNo(btind) & isnan(BTrainingPreTestTurnDirection)==0));
            CTrainingPreTestHeading(btind)=rad2ang(circ_mean(ang2rad(BTrainingPreTestHeading(BTrainingPreTestAntIDNo==CTrainingPreTestAntIDNo(btind) & isnan(BTrainingPreTestHeading)==0))));
        end

        %Test1
        CTest1AntIDNo=unique(BTest1AntIDNo);
        CTest1Var=NaN(size(CTest1AntIDNo));
        CTest1Sinuosity=NaN(size(CTest1AntIDNo));
        CTest1StartVar=NaN(size(CTest1AntIDNo));
        CTest1TurnAmplitude=NaN(size(CTest1AntIDNo));
        CTest1TurnDirection=NaN(size(CTest1AntIDNo));
        CTest1Heading=NaN(size(CTest1AntIDNo));
        for btind=1:length(CTest1AntIDNo)
            CTest1Var(btind)=rad2ang(circ_mean(ang2rad(BTest1Var(BTest1AntIDNo==CTest1AntIDNo(btind) & isnan(BTest1Var)==0))));
            CTest1Sinuosity(btind)=mean(BTest1Sinuosity(BTest1AntIDNo==CTest1AntIDNo(btind) & isnan(BTest1Sinuosity)==0));
            CTest1StartVar(btind)=rad2ang(circ_mean(ang2rad(BTest1StartVar(BTest1AntIDNo==CTest1AntIDNo(btind) & isnan(BTest1StartVar)==0))));
            CTest1TurnAmplitude(btind)=rad2ang(circ_mean(ang2rad(BTest1TurnAmplitude(BTest1AntIDNo==CTest1AntIDNo(btind) & isnan(BTest1TurnAmplitude)==0))));
            CTest1TurnDirection(btind)=mean(BTest1TurnDirection(BTest1AntIDNo==CTest1AntIDNo(btind) & isnan(BTest1TurnDirection)==0));
            CTest1Heading(btind)=rad2ang(circ_mean(ang2rad(BTest1Heading(BTest1AntIDNo==CTest1AntIDNo(btind) & isnan(BTest1Heading)==0))));
        end

        %Test2
        CTest2AntIDNo=unique(BTest2AntIDNo);
        CTest2Var=NaN(size(CTest2AntIDNo));
        CTest2Sinuosity=NaN(size(CTest2AntIDNo));
        CTest2StartVar=NaN(size(CTest2AntIDNo));
        CTest2TurnAmplitude=NaN(size(CTest2AntIDNo));
        CTest2TurnDirection=NaN(size(CTest2AntIDNo));
        CTest2Heading=NaN(size(CTest2AntIDNo));
        for btind=1:length(CTest2AntIDNo)
            CTest2Var(btind)=rad2ang(circ_mean(ang2rad(BTest2Var(BTest2AntIDNo==CTest2AntIDNo(btind) & isnan(BTest2Var)==0))));
            CTest2Sinuosity(btind)=mean(BTest2Sinuosity(BTest2AntIDNo==CTest2AntIDNo(btind) & isnan(BTest2Sinuosity)==0));
            CTest2StartVar(btind)=rad2ang(circ_mean(ang2rad(BTest2StartVar(BTest2AntIDNo==CTest2AntIDNo(btind) & isnan(BTest2StartVar)==0))));
            CTest2TurnAmplitude(btind)=rad2ang(circ_mean(ang2rad(BTest2TurnAmplitude(BTest2AntIDNo==CTest2AntIDNo(btind) & isnan(BTest2TurnAmplitude)==0))));
            CTest2TurnDirection(btind)=mean(BTest2TurnDirection(BTest2AntIDNo==CTest2AntIDNo(btind) & isnan(BTest2TurnDirection)==0));
            CTest2Heading(btind)=rad2ang(circ_mean(ang2rad(BTest2Heading(BTest2AntIDNo==CTest2AntIDNo(btind) & isnan(BTest2Heading)==0))));
        end

        %Test3
        CTest3AntIDNo=unique(BTest3AntIDNo);
        CTest3Var=NaN(size(CTest3AntIDNo));
        CTest3Sinuosity=NaN(size(CTest3AntIDNo));
        CTest3StartVar=NaN(size(CTest3AntIDNo));
        CTest3TurnAmplitude=NaN(size(CTest3AntIDNo));
        CTest3TurnDirection=NaN(size(CTest3AntIDNo));
        CTest3Heading=NaN(size(CTest3AntIDNo));
        for btind=1:length(CTest3AntIDNo)
            CTest3Var(btind)=rad2ang(circ_mean(ang2rad(BTest3Var(BTest3AntIDNo==CTest3AntIDNo(btind) & isnan(BTest3Var)==0))));
            CTest3Sinuosity(btind)=mean(BTest3Sinuosity(BTest3AntIDNo==CTest3AntIDNo(btind) & isnan(BTest3Sinuosity)==0));
            CTest3StartVar(btind)=rad2ang(circ_mean(ang2rad(BTest3StartVar(BTest3AntIDNo==CTest3AntIDNo(btind) & isnan(BTest3StartVar)==0))));
            CTest3TurnAmplitude(btind)=rad2ang(circ_mean(ang2rad(BTest3TurnAmplitude(BTest3AntIDNo==CTest3AntIDNo(btind) & isnan(BTest3TurnAmplitude)==0))));
            CTest3TurnDirection(btind)=mean(BTest3TurnDirection(BTest3AntIDNo==CTest3AntIDNo(btind) & isnan(BTest3TurnDirection)==0));
            CTest3Heading(btind)=rad2ang(circ_mean(ang2rad(BTest3Heading(BTest3AntIDNo==CTest3AntIDNo(btind) & isnan(BTest3Heading)==0))));
        end
    elseif avetype==2 %medians
        %All training
        CTrainingAllAntIDNo=unique(BTrainingAllAntIDNo);
        CTrainingAllVar=NaN(size(CTrainingAllAntIDNo));
        CTrainingAllSinuosity=NaN(size(CTrainingAllAntIDNo));
        CTrainingAllStartVar=NaN(size(CTrainingAllAntIDNo));
        CTrainingAllTurnAmplitude=NaN(size(CTrainingAllAntIDNo));
        CTrainingAllTurnDirection=NaN(size(CTrainingAllAntIDNo));
        CTrainingAllHeading=NaN(size(CTrainingAllAntIDNo));
        for btind=1:length(CTrainingAllAntIDNo)
            CTrainingAllVar(btind)=rad2ang(circ_median(ang2rad(BTrainingAllVar(BTrainingAllAntIDNo==CTrainingAllAntIDNo(btind) & isnan(BTrainingAllVar)==0))));
            CTrainingAllSinuosity(btind)=median(BTrainingAllSinuosity(BTrainingAllAntIDNo==CTrainingAllAntIDNo(btind) & isnan(BTrainingAllSinuosity)==0));
            CTrainingAllStartVar(btind)=rad2ang(circ_median(ang2rad(BTrainingAllStartVar(BTrainingAllAntIDNo==CTrainingAllAntIDNo(btind) & isnan(BTrainingAllStartVar)==0))));
            CTrainingAllTurnAmplitude(btind)=rad2ang(circ_median(ang2rad(BTrainingAllTurnAmplitude(BTrainingAllAntIDNo==CTrainingAllAntIDNo(btind) & isnan(BTrainingAllTurnAmplitude)==0))));
            CTrainingAllTurnDirection(btind)=median(BTrainingAllTurnDirection(BTrainingAllAntIDNo==CTrainingAllAntIDNo(btind) & isnan(BTrainingAllTurnDirection)==0));
            CTrainingAllHeading(btind)=rad2ang(circ_median(ang2rad(BTrainingAllHeading(BTrainingAllAntIDNo==CTrainingAllAntIDNo(btind) & isnan(BTrainingAllHeading)==0))));

        end

        %Pretest training
        CTrainingPreTestAntIDNo=unique(BTrainingPreTestAntIDNo);
        CTrainingPreTestVar=NaN(size(CTrainingPreTestAntIDNo));
        CTrainingPreTestSinuosity=NaN(size(CTrainingPreTestAntIDNo));
        CTrainingPreTestStartVar=NaN(size(CTrainingPreTestAntIDNo));
        CTrainingPreTestTurnAmplitude=NaN(size(CTrainingPreTestAntIDNo));
        CTrainingPreTestTurnDirection=NaN(size(CTrainingPreTestAntIDNo));
        CTrainingPreTestHeading=NaN(size(CTrainingPreTestAntIDNo));
        for btind=1:length(CTrainingPreTestAntIDNo)
            CTrainingPreTestVar(btind)=rad2ang(circ_mdiean(ang2rad(BTrainingPreTestVar(BTrainingPreTestAntIDNo==CTrainingPreTestAntIDNo(btind) & isnan(BTrainingPreTestVar)==0))));
            CTrainingPreTestSinuosity(btind)=median(BTrainingPreTestSinuosity(BTrainingPreTestAntIDNo==CTrainingPreTestAntIDNo(btind) & isnan(BTrainingPreTestSinuosity)==0));
            CTrainingPreTestStartVar(btind)=rad2ang(circ_median(ang2rad(BTrainingPreTestStartVar(BTrainingPreTestAntIDNo==CTrainingPreTestAntIDNo(btind) & isnan(BTrainingPreTestStartVar)==0))));
            CTrainingPreTestTurnAmplitude(btind)=rad2ang(circ_median(ang2rad(BTrainingPreTestTurnAmplitude(BTrainingPreTestAntIDNo==CTrainingPreTestAntIDNo(btind) & isnan(BTrainingPreTestTurnAmplitude)==0))));
            CTrainingPreTestTurnDirection(btind)=median(BTrainingPreTestTurnDirection(BTrainingPreTestAntIDNo==CTrainingPreTestAntIDNo(btind) & isnan(BTrainingPreTestTurnDirection)==0));
            CTrainingPreTestHeading(btind)=rad2ang(circ_median(ang2rad(BTrainingPreTestHeading(BTrainingPreTestAntIDNo==CTrainingPreTestAntIDNo(btind) & isnan(BTrainingPreTestHeading)==0))));
        end

        %Test1
        CTest1AntIDNo=unique(BTest1AntIDNo);
        CTest1Var=NaN(size(CTest1AntIDNo));
        CTest1Sinuosity=NaN(size(CTest1AntIDNo));
        CTest1StartVar=NaN(size(CTest1AntIDNo));
        CTest1TurnAmplitude=NaN(size(CTest1AntIDNo));
        CTest1TurnDirection=NaN(size(CTest1AntIDNo));
        CTest1Heading=NaN(size(CTest1AntIDNo));
        for btind=1:length(CTest1AntIDNo)
            CTest1Var(btind)=rad2ang(circ_median(ang2rad(BTest1Var(BTest1AntIDNo==CTest1AntIDNo(btind) & isnan(BTest1Var)==0))));
            CTest1Sinuosity(btind)=median(BTest1Sinuosity(BTest1AntIDNo==CTest1AntIDNo(btind) & isnan(BTest1Sinuosity)==0));
            CTest1StartVar(btind)=rad2ang(circ_median(ang2rad(BTest1StartVar(BTest1AntIDNo==CTest1AntIDNo(btind) & isnan(BTest1StartVar)==0))));
            CTest1TurnAmplitude(btind)=rad2ang(circ_median(ang2rad(BTest1TurnAmplitude(BTest1AntIDNo==CTest1AntIDNo(btind) & isnan(BTest1TurnAmplitude)==0))));
            CTest1TurnDirection(btind)=median(BTest1TurnDirection(BTest1AntIDNo==CTest1AntIDNo(btind) & isnan(BTest1TurnDirection)==0));
            CTest1Heading(btind)=rad2ang(circ_median(ang2rad(BTest1Heading(BTest1AntIDNo==CTest1AntIDNo(btind) & isnan(BTest1Heading)==0))));

        end

        %Test2
        CTest2AntIDNo=unique(BTest2AntIDNo);
        CTest2Var=NaN(size(CTest2AntIDNo));
        CTest2Sinuosity=NaN(size(CTest2AntIDNo));
        CTest2StartVar=NaN(size(CTest2AntIDNo));
        CTest2TurnAmplitude=NaN(size(CTest2AntIDNo));
        CTest2TurnDirection=NaN(size(CTest2AntIDNo));
        CTest2Heading=NaN(size(CTest2AntIDNo));
        for btind=1:length(CTest2AntIDNo)
            CTest2Var(btind)=rad2ang(circ_median(ang2rad(BTest2Var(BTest2AntIDNo==CTest2AntIDNo(btind) & isnan(BTest2Var)==0))));
            CTest2Sinuosity(btind)=median(BTest2Sinuosity(BTest2AntIDNo==CTest2AntIDNo(btind) & isnan(BTest2Sinuosity)==0));
            CTest2StartVar(btind)=rad2ang(circ_median(ang2rad(BTest2StartVar(BTest2AntIDNo==CTest2AntIDNo(btind) & isnan(BTest2StartVar)==0))));
            CTest2TurnAmplitude(btind)=rad2ang(circ_median(ang2rad(BTest2TurnAmplitude(BTest2AntIDNo==CTest2AntIDNo(btind) & isnan(BTest2TurnAmplitude)==0))));
            CTest2TurnDirection(btind)=median(BTest2TurnDirection(BTest2AntIDNo==CTest2AntIDNo(btind) & isnan(BTest2TurnDirection)==0));
            CTest2Heading(btind)=rad2ang(circ_median(ang2rad(BTest2Heading(BTest2AntIDNo==CTest2AntIDNo(btind) & isnan(BTest2Heading)==0))));
        end

        %Test3
        CTest3AntIDNo=unique(BTest3AntIDNo);
        CTest3Var=NaN(size(CTest3AntIDNo));
        CTest3Sinuosity=NaN(size(CTest3AntIDNo));
        CTest3StartVar=NaN(size(CTest3AntIDNo));
        CTest3TurnAmplitude=NaN(size(CTest3AntIDNo));
        CTest3TurnDirection=NaN(size(CTest3AntIDNo));
        CTest3Heading=NaN(size(CTest3AntIDNo));
        for btind=1:length(CTest3AntIDNo)
            CTest3Var(btind)=rad2ang(circ_median(ang2rad(BTest3Var(BTest3AntIDNo==CTest3AntIDNo(btind) & isnan(BTest3Var)==0))));
            CTest3Sinuosity(btind)=median(BTest3Sinuosity(BTest3AntIDNo==CTest3AntIDNo(btind) & isnan(BTest3Sinuosity)==0));
            CTest3StartVar(btind)=rad2ang(circ_median(ang2rad(BTest3StartVar(BTest3AntIDNo==CTest3AntIDNo(btind) & isnan(BTest3StartVar)==0))));
            CTest3TurnAmplitude(btind)=rad2ang(circ_median(ang2rad(BTest3TurnAmplitude(BTest3AntIDNo==CTest3AntIDNo(btind) & isnan(BTest3TurnAmplitude)==0))));
            CTest3TurnDirection(btind)=median(BTest3TurnDirection(BTest3AntIDNo==CTest3AntIDNo(btind) & isnan(BTest3TurnDirection)==0));
            CTest3Heading(btind)=rad2ang(circ_median(ang2rad(BTest3Heading(BTest3AntIDNo==CTest3AntIDNo(btind) & isnan(BTest3Heading)==0))));
        end
    end %if avetype==1 %means
    %% Work out medians for each path
    % BTrainingAllVar=BTrainingAllVar(isnan(BTrainingAllVar)==0);
    % BTrainingPreTestVar=BTrainingPreTestVar(isnan(BTrainingPreTestVar)==0);
    % BTest1Var=BTest1Var(isnan(BTest1Var)==0);
    % BTest2Var=BTest2Var(isnan(BTest2Var)==0);
    % BTest2Var=BTest2Var(isnan(BTest2Var)==0);
    
    if avetype==1 %means
        %All training
         BTrainingAllAntRun=[BTrainingAllAntIDNo BTrainingAllRunNo];
         [~, DTrainingAllAntRunNo, BTrainingAllAntRunNo]=unique(BTrainingAllAntRun,'rows');
        DTrainingAllAntRun=BTrainingAllAntRun(DTrainingAllAntRunNo,:);
        DTrainingAllAntIDNo=BTrainingAllAntIDNo(DTrainingAllAntRunNo);
        DTrainingAllRunNo=BTrainingAllRunNo(DTrainingAllAntRunNo);
        DTrainingAllVar=NaN(size(DTrainingAllAntIDNo));
        DTrainingAllSinuosity=NaN(size(DTrainingAllAntIDNo));
        DTrainingAllStartVar=NaN(size(DTrainingAllAntIDNo));
        DTrainingAllTurnAmplitude=NaN(size(DTrainingAllAntIDNo));
        DTrainingAllTurnDirection=NaN(size(DTrainingAllAntIDNo));
        DTrainingAllHeading=NaN(size(DTrainingAllAntIDNo));
        for btind=1:length(DTrainingAllAntIDNo)
            DTrainingAllVar(btind)=rad2ang(circ_mean(ang2rad(BTrainingAllVar(BTrainingAllAntRunNo==btind & isnan(BTrainingAllVar)==0))));
            DTrainingAllSinuosity(btind)=mean(BTrainingAllSinuosity(BTrainingAllAntRunNo==btind & isnan(BTrainingAllSinuosity)==0));
            DTrainingAllStartVar(btind)=rad2ang(circ_mean(ang2rad(BTrainingAllStartVar(BTrainingAllAntRunNo==btind & isnan(BTrainingAllStartVar)==0))));
            DTrainingAllTurnAmplitude(btind)=rad2ang(circ_mean(ang2rad(BTrainingAllTurnAmplitude(BTrainingAllAntRunNo==btind & isnan(BTrainingAllTurnAmplitude)==0))));
            DTrainingAllTurnDirection(btind)=mean(BTrainingAllTurnDirection(BTrainingAllAntRunNo==btind & isnan(BTrainingAllTurnDirection)==0));
            DTrainingAllHeading(btind)=rad2ang(circ_mean(ang2rad(BTrainingAllHeading(BTrainingAllAntRunNo==btind & isnan(BTrainingAllHeading)==0))));
        end

        %Pretest training
          BTrainingPreTestAntRun=[BTrainingPreTestAntIDNo BTrainingPreTestRunNo];
         [~, DTrainingPreTestAntRunNo, BTrainingPreTestAntRunNo]=unique(BTrainingPreTestAntRun,'rows');
        DTrainingPreTestAntRun=BTrainingPreTestAntRun(DTrainingPreTestAntRunNo,:);
        DTrainingPreTestAntIDNo=BTrainingPreTestAntIDNo(DTrainingPreTestAntRunNo);
        DTrainingPreTestRunNo=BTrainingPreTestRunNo(DTrainingPreTestAntRunNo);
        DTrainingPreTestVar=NaN(size(DTrainingPreTestAntIDNo));
        DTrainingPreTestSinuosity=NaN(size(DTrainingPreTestAntIDNo));
        DTrainingPreTestStartVar=NaN(size(DTrainingPreTestAntIDNo));
        DTrainingPreTestTurnAmplitude=NaN(size(DTrainingPreTestAntIDNo));
        DTrainingPreTestTurnDirection=NaN(size(DTrainingPreTestAntIDNo));
        DTrainingPreTestHeading=NaN(size(DTrainingPreTestAntIDNo));
        for btind=1:length(DTrainingPreTestAntIDNo)
            DTrainingPreTestVar(btind)=rad2ang(circ_mean(ang2rad(BTrainingPreTestVar(BTrainingPreTestAntRunNo==btind & isnan(BTrainingPreTestVar)==0))));
            DTrainingPreTestSinuosity(btind)=mean(BTrainingPreTestSinuosity(BTrainingPreTestAntRunNo==btind & isnan(BTrainingPreTestSinuosity)==0));
            DTrainingPreTestStartVar(btind)=rad2ang(circ_mean(ang2rad(BTrainingPreTestStartVar(BTrainingPreTestAntRunNo==btind & isnan(BTrainingPreTestStartVar)==0))));
            DTrainingPreTestTurnAmplitude(btind)=rad2ang(circ_mean(ang2rad(BTrainingPreTestTurnAmplitude(BTrainingPreTestAntRunNo==btind & isnan(BTrainingPreTestTurnAmplitude)==0))));
            DTrainingPreTestTurnDirection(btind)=mean(BTrainingPreTestTurnDirection(BTrainingPreTestAntRunNo==btind & isnan(BTrainingPreTestTurnDirection)==0));
            DTrainingPreTestHeading(btind)=rad2ang(circ_mean(ang2rad(BTrainingPreTestHeading(BTrainingPreTestAntRunNo==btind & isnan(BTrainingPreTestHeading)==0))));
        end


        %Test1
         BTest1AntRun=[BTest1AntIDNo BTest1RunNo];
         [~, DTest1AntRunNo, BTest1AntRunNo]=unique(BTest1AntRun,'rows');
        DTest1AntRun=BTest1AntRun(DTest1AntRunNo,:);
        DTest1AntIDNo=BTest1AntIDNo(DTest1AntRunNo);
        DTest1RunNo=BTest1RunNo(DTest1AntRunNo);
        DTest1Var=NaN(size(DTest1AntIDNo));
        DTest1Sinuosity=NaN(size(DTest1AntIDNo));
        DTest1StartVar=NaN(size(DTest1AntIDNo));
        DTest1TurnAmplitude=NaN(size(DTest1AntIDNo));
        DTest1TurnDirection=NaN(size(DTest1AntIDNo));
        DTest1Heading=NaN(size(DTest1AntIDNo));
        for btind=1:length(DTest1AntIDNo)
            DTest1Var(btind)=rad2ang(circ_mean(ang2rad(BTest1Var(BTest1AntRunNo==btind & isnan(BTest1Var)==0))));
            DTest1Sinuosity(btind)=mean(BTest1Sinuosity(BTest1AntRunNo==btind & isnan(BTest1Sinuosity)==0));
            DTest1StartVar(btind)=rad2ang(circ_mean(ang2rad(BTest1StartVar(BTest1AntRunNo==btind & isnan(BTest1StartVar)==0))));
            DTest1TurnAmplitude(btind)=rad2ang(circ_mean(ang2rad(BTest1TurnAmplitude(BTest1AntRunNo==btind & isnan(BTest1TurnAmplitude)==0))));
            DTest1TurnDirection(btind)=mean(BTest1TurnDirection(BTest1AntRunNo==btind & isnan(BTest1TurnDirection)==0));
            DTest1Heading(btind)=rad2ang(circ_mean(ang2rad(BTest1Heading(BTest1AntRunNo==btind & isnan(BTest1Heading)==0))));
        end


        %Test2
         BTest2AntRun=[BTest2AntIDNo BTest2RunNo];
         [~, DTest2AntRunNo, BTest2AntRunNo]=unique(BTest2AntRun,'rows');
        DTest2AntRun=BTest2AntRun(DTest2AntRunNo,:);
        DTest2AntIDNo=BTest2AntIDNo(DTest2AntRunNo);
        DTest2RunNo=BTest2RunNo(DTest2AntRunNo);
        DTest2Var=NaN(size(DTest2AntIDNo));
        DTest2Sinuosity=NaN(size(DTest2AntIDNo));
        DTest2StartVar=NaN(size(DTest2AntIDNo));
        DTest2TurnAmplitude=NaN(size(DTest2AntIDNo));
        DTest2TurnDirection=NaN(size(DTest2AntIDNo));
        DTest2Heading=NaN(size(DTest2AntIDNo));
        for btind=1:length(DTest2AntIDNo)
            DTest2Var(btind)=rad2ang(circ_mean(ang2rad(BTest2Var(BTest2AntRunNo==btind & isnan(BTest2Var)==0))));
            DTest2Sinuosity(btind)=mean(BTest2Sinuosity(BTest2AntRunNo==btind & isnan(BTest2Sinuosity)==0));
            DTest2StartVar(btind)=rad2ang(circ_mean(ang2rad(BTest2StartVar(BTest2AntRunNo==btind & isnan(BTest2StartVar)==0))));
            DTest2TurnAmplitude(btind)=rad2ang(circ_mean(ang2rad(BTest2TurnAmplitude(BTest2AntRunNo==btind & isnan(BTest2TurnAmplitude)==0))));
            DTest2TurnDirection(btind)=mean(BTest2TurnDirection(BTest2AntRunNo==btind & isnan(BTest2TurnDirection)==0));
            DTest2Heading(btind)=rad2ang(circ_mean(ang2rad(BTest2Heading(BTest2AntRunNo==btind & isnan(BTest2Heading)==0))));
        end


        %Test3
         BTest3AntRun=[BTest3AntIDNo BTest3RunNo];
         [~, DTest3AntRunNo, BTest3AntRunNo]=unique(BTest3AntRun,'rows');
        DTest3AntRun=BTest3AntRun(DTest3AntRunNo,:);
        DTest3AntIDNo=BTest3AntIDNo(DTest3AntRunNo);
        DTest3RunNo=BTest3RunNo(DTest3AntRunNo);
        DTest3Var=NaN(size(DTest3AntIDNo));
        DTest3Sinuosity=NaN(size(DTest3AntIDNo));
        DTest3StartVar=NaN(size(DTest3AntIDNo));
        DTest3TurnAmplitude=NaN(size(DTest3AntIDNo));
        DTest3TurnDirection=NaN(size(DTest3AntIDNo));
        DTest3Heading=NaN(size(DTest3AntIDNo));
        for btind=1:length(DTest3AntIDNo)
            DTest3Var(btind)=rad2ang(circ_mean(ang2rad(BTest3Var(BTest3AntRunNo==btind & isnan(BTest3Var)==0))));
            DTest3Sinuosity(btind)=mean(BTest3Sinuosity(BTest3AntRunNo==btind & isnan(BTest3Sinuosity)==0));
            DTest3StartVar(btind)=rad2ang(circ_mean(ang2rad(BTest3StartVar(BTest3AntRunNo==btind & isnan(BTest3StartVar)==0))));
            DTest3TurnAmplitude(btind)=rad2ang(circ_mean(ang2rad(BTest3TurnAmplitude(BTest3AntRunNo==btind & isnan(BTest3TurnAmplitude)==0))));
            DTest3TurnDirection(btind)=mean(BTest3TurnDirection(BTest3AntRunNo==btind & isnan(BTest3TurnDirection)==0));
            DTest3Heading(btind)=rad2ang(circ_mean(ang2rad(BTest3Heading(BTest3AntRunNo==btind & isnan(BTest3Heading)==0))));
        end
        
    elseif avetype==2 %medians
    
        %All training
         BTrainingAllAntRun=[BTrainingAllAntIDNo BTrainingAllRunNo];
         [~, DTrainingAllAntRunNo, BTrainingAllAntRunNo]=unique(BTrainingAllAntRun,'rows');
        DTrainingAllAntRun=BTrainingAllAntRun(DTrainingAllAntRunNo,:);
        DTrainingAllAntIDNo=BTrainingAllAntIDNo(DTrainingAllAntRunNo);
        DTrainingAllRunNo=BTrainingAllRunNo(DTrainingAllAntRunNo);
        DTrainingAllVar=NaN(size(DTrainingAllAntIDNo));
        DTrainingAllSinuosity=NaN(size(DTrainingAllAntIDNo));
        DTrainingAllStartVar=NaN(size(DTrainingAllAntIDNo));
        DTrainingAllTurnAmplitude=NaN(size(DTrainingAllAntIDNo));
        DTrainingAllTurnDirection=NaN(size(DTrainingAllAntIDNo));
        DTrainingAllHeading=NaN(size(DTrainingAllAntIDNo));
        for btind=1:length(DTrainingAllAntIDNo)
            DTrainingAllVar(btind)=rad2ang(circ_median(ang2rad(BTrainingAllVar(BTrainingAllAntRunNo==btind & isnan(BTrainingAllVar)==0))));
            DTrainingAllSinuosity(btind)=median(BTrainingAllSinuosity(BTrainingAllAntRunNo==btind & isnan(BTrainingAllSinuosity)==0));
            DTrainingAllStartVar(btind)=rad2ang(circ_median(ang2rad(BTrainingAllStartVar(BTrainingAllAntRunNo==btind & isnan(BTrainingAllStartVar)==0))));
            DTrainingAllTurnAmplitude(btind)=rad2ang(circ_median(ang2rad(BTrainingAllTurnAmplitude(BTrainingAllAntRunNo==btind & isnan(BTrainingAllTurnAmplitude)==0))));
            DTrainingAllTurnDirection(btind)=median(BTrainingAllTurnDirection(BTrainingAllAntRunNo==btind & isnan(BTrainingAllTurnDirection)==0));
            DTrainingAllHeading(btind)=rad2ang(circ_median(ang2rad(BTrainingAllHeading(BTrainingAllAntRunNo==btind & isnan(BTrainingAllHeading)==0))));
        end

        %Pretest training
          BTrainingPreTestAntRun=[BTrainingPreTestAntIDNo BTrainingPreTestRunNo];
         [~, DTrainingPreTestAntRunNo, BTrainingPreTestAntRunNo]=unique(BTrainingPreTestAntRun,'rows');
        DTrainingPreTestAntRun=BTrainingPreTestAntRun(DTrainingPreTestAntRunNo,:);
        DTrainingPreTestAntIDNo=BTrainingPreTestAntIDNo(DTrainingPreTestAntRunNo);
        DTrainingPreTestRunNo=BTrainingPreTestRunNo(DTrainingPreTestAntRunNo);
        DTrainingPreTestVar=NaN(size(DTrainingPreTestAntIDNo));
        DTrainingPreTestSinuosity=NaN(size(DTrainingPreTestAntIDNo));
        DTrainingPreTestStartVar=NaN(size(DTrainingPreTestAntIDNo));
        DTrainingPreTestTurnAmplitude=NaN(size(DTrainingPreTestAntIDNo));
        DTrainingPreTestTurnDirection=NaN(size(DTrainingPreTestAntIDNo));
        DTrainingPreTestHeading=NaN(size(DTrainingPreTestAntIDNo));
        for btind=1:length(DTrainingPreTestAntIDNo)
            DTrainingPreTestVar(btind)=rad2ang(circ_median(ang2rad(BTrainingPreTestVar(BTrainingPreTestAntRunNo==btind & isnan(BTrainingPreTestVar)==0))));
            DTrainingPreTestSinuosity(btind)=median(BTrainingPreTestSinuosity(BTrainingPreTestAntRunNo==btind & isnan(BTrainingPreTestSinuosity)==0));
            DTrainingPreTestStartVar(btind)=rad2ang(circ_median(ang2rad(BTrainingPreTestStartVar(BTrainingPreTestAntRunNo==btind & isnan(BTrainingPreTestStartVar)==0))));
            DTrainingPreTestTurnAmplitude(btind)=rad2ang(circ_median(ang2rad(BTrainingPreTestTurnAmplitude(BTrainingPreTestAntRunNo==btind & isnan(BTrainingPreTestTurnAmplitude)==0))));
            DTrainingPreTestTurnDirection(btind)=median(BTrainingPreTestTurnDirection(BTrainingPreTestAntRunNo==btind & isnan(BTrainingPreTestTurnDirection)==0));
            DTrainingPreTestHeading(btind)=rad2ang(circ_median(ang2rad(BTrainingPreTestHeading(BTrainingPreTestAntRunNo==btind & isnan(BTrainingPreTestHeading)==0))));
        end


        %Test1
         BTest1AntRun=[BTest1AntIDNo BTest1RunNo];
         [~, DTest1AntRunNo, BTest1AntRunNo]=unique(BTest1AntRun,'rows');
        DTest1AntRun=BTest1AntRun(DTest1AntRunNo,:);
        DTest1AntIDNo=BTest1AntIDNo(DTest1AntRunNo);
        DTest1RunNo=BTest1RunNo(DTest1AntRunNo);
        DTest1Var=NaN(size(DTest1AntIDNo));
        DTest1Sinuosity=NaN(size(DTest1AntIDNo));
        DTest1StartVar=NaN(size(DTest1AntIDNo));
        DTest1TurnAmplitude=NaN(size(DTest1AntIDNo));
        DTest1TurnDirection=NaN(size(DTest1AntIDNo));
        DTest1Heading=NaN(size(DTest1AntIDNo));
        for btind=1:length(DTest1AntIDNo)
            DTest1Var(btind)=rad2ang(circ_median(ang2rad(BTest1Var(BTest1AntRunNo==btind & isnan(BTest1Var)==0))));
            DTest1Sinuosity(btind)=median(BTest1Sinuosity(BTest1AntRunNo==btind & isnan(BTest1Sinuosity)==0));
            DTest1StartVar(btind)=rad2ang(circ_median(ang2rad(BTest1StartVar(BTest1AntRunNo==btind & isnan(BTest1StartVar)==0))));
            DTest1TurnAmplitude(btind)=rad2ang(circ_median(ang2rad(BTest1TurnAmplitude(BTest1AntRunNo==btind & isnan(BTest1TurnAmplitude)==0))));
            DTest1TurnDirection(btind)=median(BTest1TurnDirection(BTest1AntRunNo==btind & isnan(BTest1TurnDirection)==0));
            DTest1Heading(btind)=rad2ang(circ_median(ang2rad(BTest1Heading(BTest1AntRunNo==btind & isnan(BTest1Heading)==0))));
        end


        %Test2
         BTest2AntRun=[BTest2AntIDNo BTest2RunNo];
         [~, DTest2AntRunNo, BTest2AntRunNo]=unique(BTest2AntRun,'rows');
        DTest2AntRun=BTest2AntRun(DTest2AntRunNo,:);
        DTest2AntIDNo=BTest2AntIDNo(DTest2AntRunNo);
        DTest2RunNo=BTest2RunNo(DTest2AntRunNo);
        DTest2Var=NaN(size(DTest2AntIDNo));
        DTest2Sinuosity=NaN(size(DTest2AntIDNo));
        DTest2StartVar=NaN(size(DTest2AntIDNo));
        DTest2TurnAmplitude=NaN(size(DTest2AntIDNo));
        DTest2TurnDirection=NaN(size(DTest2AntIDNo));
        DTest2Heading=NaN(size(DTest2AntIDNo));
        for btind=1:length(DTest2AntIDNo)
            DTest2Var(btind)=rad2ang(circ_median(ang2rad(BTest2Var(BTest2AntRunNo==btind & isnan(BTest2Var)==0))));
            DTest2Sinuosity(btind)=median(BTest2Sinuosity(BTest2AntRunNo==btind & isnan(BTest2Sinuosity)==0));
            DTest2StartVar(btind)=rad2ang(circ_median(ang2rad(BTest2StartVar(BTest2AntRunNo==btind & isnan(BTest2StartVar)==0))));
            DTest2TurnAmplitude(btind)=rad2ang(circ_median(ang2rad(BTest2TurnAmplitude(BTest2AntRunNo==btind & isnan(BTest2TurnAmplitude)==0))));
            DTest2TurnDirection(btind)=median(BTest2TurnDirection(BTest2AntRunNo==btind & isnan(BTest2TurnDirection)==0));
            DTest2Heading(btind)=rad2ang(circ_median(ang2rad(BTest2Heading(BTest2AntRunNo==btind & isnan(BTest2Heading)==0))));
        end


        %Test3
         BTest3AntRun=[BTest3AntIDNo BTest3RunNo];
         [~, DTest3AntRunNo, BTest3AntRunNo]=unique(BTest3AntRun,'rows');
        DTest3AntRun=BTest3AntRun(DTest3AntRunNo,:);
        DTest3AntIDNo=BTest3AntIDNo(DTest3AntRunNo);
        DTest3RunNo=BTest3RunNo(DTest3AntRunNo);
        DTest3Var=NaN(size(DTest3AntIDNo));
        DTest3Sinuosity=NaN(size(DTest3AntIDNo));
        DTest3StartVar=NaN(size(DTest3AntIDNo));
        DTest3TurnAmplitude=NaN(size(DTest3AntIDNo));
        DTest3TurnDirection=NaN(size(DTest3AntIDNo));
        DTest3Heading=NaN(size(DTest3AntIDNo));
        for btind=1:length(DTest3AntIDNo)
            DTest3Var(btind)=rad2ang(circ_median(ang2rad(BTest3Var(BTest3AntRunNo==btind & isnan(BTest3Var)==0))));
            DTest3Sinuosity(btind)=median(BTest3Sinuosity(BTest3AntRunNo==btind & isnan(BTest3Sinuosity)==0));
            DTest3StartVar(btind)=rad2ang(circ_median(ang2rad(BTest3StartVar(BTest3AntRunNo==btind & isnan(BTest3StartVar)==0))));
            DTest3TurnAmplitude(btind)=rad2ang(circ_median(ang2rad(BTest3TurnAmplitude(BTest3AntRunNo==btind & isnan(BTest3TurnAmplitude)==0))));
            DTest3TurnDirection(btind)=median(BTest3TurnDirection(BTest3AntRunNo==btind & isnan(BTest3TurnDirection)==0));
            DTest3Heading(btind)=rad2ang(circ_median(ang2rad(BTest3Heading(BTest3AntRunNo==btind & isnan(BTest3Heading)==0))));
        end

    end %    if avetype==1 %means

    
    %% %Calculate descriptive stats
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %CALCULATE DESCRIPTIVE STATS & COM/FPM PREDICTIONS    
    means.stat=NaN*zeros(4,1);
    means.low=NaN*zeros(4,1);
    means.high=NaN*zeros(4,1);
    means.alt=NaN*zeros(4,1);

    medians.stat=NaN*zeros(4,1);
    medians.low=NaN*zeros(4,1);
    medians.high=NaN*zeros(4,1);
    medians.alt=NaN*zeros(4,1);

    linearmedians.stat=NaN*zeros(4,1);
    linearmedians.low=NaN*zeros(4,1);
    linearmedians.high=NaN*zeros(4,1);
    linearmedians.alt=NaN*zeros(4,1);

    perantmeans.stat=NaN*zeros(4,1);
    perantmeans.low=NaN*zeros(4,1);
    perantmeans.high=NaN*zeros(4,1);
    perantmeans.alt=NaN*zeros(4,1);

    perantmedians.stat=NaN*zeros(4,1);
    perantmedians.low=NaN*zeros(4,1);
    perantmedians.high=NaN*zeros(4,1);
    perantmedians.alt=NaN*zeros(4,1);

    perantlinearmedians.stat=NaN*zeros(4,1);
    perantlinearmedians.low=NaN*zeros(4,1);
    perantlinearmedians.high=NaN*zeros(4,1);
    perantlinearmedians.alt=NaN*zeros(4,1);
    
    perrunmeans.stat=NaN*zeros(4,1);
    perrunmeans.low=NaN*zeros(4,1);
    perrunmeans.high=NaN*zeros(4,1);
    perrunmeans.alt=NaN*zeros(4,1);

    perrunmedians.stat=NaN*zeros(4,1);
    perrunmedians.low=NaN*zeros(4,1);
    perrunmedians.high=NaN*zeros(4,1);
    perrunmedians.alt=NaN*zeros(4,1);

    perrunlinearmedians.stat=NaN*zeros(4,1);
    perrunlinearmedians.low=NaN*zeros(4,1);
    perrunlinearmedians.high=NaN*zeros(4,1);
    perrunlinearmedians.alt=NaN*zeros(4,1);
    
    %%%
    tic
    %Means %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %N.B. the existing circular mean function can return 95% CIs, but I'm not
    %sure how it's calculated. Because of this I have chosen to calculate the
    %CIs using a bootstrap function to ensure they are calculated the same way
    %as the median and mode.

    if traintype==0
     [means.stat(1), means.low(1), means.high(1), ~, means.alt(1)]=bootstrapmean(BTrainingAllVar(isnan(BTrainingAllVar)==0),options.bootstrapn,0.95); 
    else
     [means.stat(1), means.low(1), means.high(1), ~, means.alt(1)]=bootstrapmean(BTrainingPreTestVar(isnan(BTrainingPreTestVar)==0),options.bootstrapn,0.95);
    end  
     [means.stat(2), means.low(2), means.high(2), ~, means.alt(2)]=bootstrapmean(BTest1Var(isnan(BTest1Var)==0),options.bootstrapn,0.95); 
        [means.stat(3), means.low(3), means.high(3), ~, means.alt(3)]=bootstrapmean(BTest2Var(isnan(BTest2Var)==0),options.bootstrapn,0.95);
        if isempty(BTest3Var)==0
         [means.stat(4), means.low(4), means.high(4), ~, means.alt(4)]=bootstrapmean(BTest3Var(isnan(BTest3Var)==0),options.bootstrapn,0.95); 
        end
    %Medians (circular) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%       
    if traintype==0
    [medians.stat(1), medians.low(1), medians.high(1)]=circmedianIQR(BTrainingAllVar(isnan(BTrainingAllVar)==0), options.mediantype,options.quantilerange, options.medianprecision, options.IQRtype);
    else  
    [medians.stat(1), medians.low(1), medians.high(1)]=circmedianIQR(BTrainingPreTestVar(isnan(BTrainingPreTestVar)==0), options.mediantype,options.quantilerange, options.medianprecision, options.IQRtype);
    end   
    [medians.stat(2), medians.low(2), medians.high(2)]=circmedianIQR(BTest1Var(isnan(BTest1Var)==0), options.mediantype,options.quantilerange, options.medianprecision, options.IQRtype);
        [medians.stat(3), medians.low(3), medians.high(3)]=circmedianIQR(BTest2Var(isnan(BTest2Var)==0), options.mediantype,options.quantilerange, options.medianprecision, options.IQRtype);
        if isempty(BTest3Var)==0
        [medians.stat(4), medians.low(4), medians.high(4)]=circmedianIQR(BTest3Var(isnan(BTest3Var)==0), options.mediantype,options.quantilerange, options.medianprecision, options.IQRtype);
        end
    %Medians (linearised) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%       
    if traintype==0 
    [linearmedians.stat(1), linearmedians.low(1), linearmedians.high(1)]=circmedianIQR(BTrainingAllVar(isnan(BTrainingAllVar)==0), 2,options.quantilerange, options.medianprecision, options.IQRtype);
    else  
    [linearmedians.stat(1), linearmedians.low(1), linearmedians.high(1)]=circmedianIQR(BTrainingPreTestVar(isnan(BTrainingPreTestVar)==0),2,options.quantilerange, options.medianprecision, options.IQRtype);
    end   
    [linearmedians.stat(2), linearmedians.low(2), linearmedians.high(2)]=circmedianIQR(BTest1Var(isnan(BTest1Var)==0),2,options.quantilerange, options.medianprecision, options.IQRtype);
        [linearmedians.stat(3), linearmedians.low(3), linearmedians.high(3)]=circmedianIQR(BTest2Var(isnan(BTest2Var)==0),2,options.quantilerange, options.medianprecision, options.IQRtype);
        if isempty(BTest3Var)==0
        [linearmedians.stat(4), linearmedians.low(4), linearmedians.high(4)]=circmedianIQR(BTest3Var(isnan(BTest3Var)==0),2,options.quantilerange, options.medianprecision, options.IQRtype);
        end
    toc

     %Calculate descriptive stats (for the medians of each run)
    %NB This OVERWRITES the medians for the entire dataset so do NOT run this
    %section if you are making histograms etc with the full dataset
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %CALCULATE DESCRIPTIVE STATS & COM/FPM PREDICTIONS    
    %%%
    tic
    %Means %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %N.B. the existing circular mean function can return 95% CIs, but I'm not
    %sure how it's calculated. Because of this I have chosen to calculate the
    %CIs using a bootstrap function to ensure they are calculated the same way
    %as the median and mode.
    if traintype==0
     [perrunmeans.stat(1), perrunmeans.low(1), perrunmeans.high(1), ~, perrunmeans.alt(1)]=bootstrapmean(DTrainingAllVar(isnan(DTrainingAllVar)==0),options.bootstrapn,0.95); 
    else 
     [perrunmeans.stat(1), perrunmeans.low(1), perrunmeans.high(1), ~, perrunmeans.alt(1)]=bootstrapmean(DTrainingPreTestVar(isnan(DTrainingPreTestVar)==0),options.bootstrapn,0.95); 
    end  
     [perrunmeans.stat(2), perrunmeans.low(2), perrunmeans.high(2), ~, perrunmeans.alt(2)]=bootstrapmean(DTest1Var(isnan(DTest1Var)==0),options.bootstrapn,0.95); 
        if length(DTest2Var)>1
        [perrunmeans.stat(3), perrunmeans.low(3), perrunmeans.high(3), ~, perrunmeans.alt(3)]=bootstrapmean(DTest2Var(isnan(DTest2Var)==0),options.bootstrapn,0.95); 
        end
        if length(DTest3Var)>1
        [perrunmeans.stat(4), perrunmeans.low(4), perrunmeans.high(4), ~, perrunmeans.alt(4)]=bootstrapmean(DTest3Var(isnan(DTest3Var)==0),options.bootstrapn,0.95); 
        end

        %Medians %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%       
    if traintype==0
        [perrunmedians.stat(1), perrunmedians.low(1), perrunmedians.high(1)]=circmedianIQR(DTrainingAllVar(isnan(DTrainingAllVar)==0), options.mediantype,options.quantilerange, options.medianprecision, options.IQRtype);
    else
        [perrunmedians.stat(1), perrunmedians.low(1), perrunmedians.high(1)]=circmedianIQR(DTrainingPreTestVar(isnan(DTrainingPreTestVar)==0), options.mediantype,options.quantilerange, options.medianprecision, options.IQRtype);
    end
        [perrunmedians.stat(2), perrunmedians.low(2), perrunmedians.high(2)]=circmedianIQR(DTest1Var(isnan(DTest1Var)==0), options.mediantype,options.quantilerange, options.medianprecision, options.IQRtype);
        if length(DTest2Var)>1
        [perrunmedians.stat(3), perrunmedians.low(3), perrunmedians.high(3)]=circmedianIQR(DTest2Var(isnan(DTest2Var)==0), options.mediantype,options.quantilerange, options.medianprecision, options.IQRtype);
        end
         if length(DTest3Var)>1
        [perrunmedians.stat(4), perrunmedians.low(4), perrunmedians.high(4)]=circmedianIQR(DTest3Var(isnan(DTest3Var)==0), options.mediantype,options.quantilerange, options.medianprecision, options.IQRtype);
         end
        %Medians %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%       
    if traintype==1
        [perrunlinearmedians.stat(1), perrunlinearmedians.low(1), perrunlinearmedians.high(1)]=circmedianIQR(DTrainingAllVar(isnan(DTrainingAllVar)==0), 2,options.quantilerange, options.medianprecision, options.IQRtype);
    else
        [perrunlinearmedians.stat(1), perrunlinearmedians.low(1), perrunlinearmedians.high(1)]=circmedianIQR(DTrainingPreTestVar(isnan(DTrainingPreTestVar)==0) ,2,options.quantilerange, options.medianprecision, options.IQRtype);
    end
        [perrunlinearmedians.stat(2), perrunlinearmedians.low(2), perrunlinearmedians.high(2)]=circmedianIQR(DTest1Var(isnan(DTest1Var)==0),2,options.quantilerange, options.medianprecision, options.IQRtype);
        if length(DTest2Var)>1
        [perrunlinearmedians.stat(3), perrunlinearmedians.low(3), perrunlinearmedians.high(3)]=circmedianIQR(DTest2Var(isnan(DTest2Var)==0),2,options.quantilerange, options.medianprecision, options.IQRtype);
        end
         if length(DTest3Var)>1
        [perrunlinearmedians.stat(4), perrunlinearmedians.low(4), perrunlinearmedians.high(4)]=circmedianIQR(DTest3Var(isnan(DTest3Var)==0),2,options.quantilerange, options.medianprecision, options.IQRtype);
         end
    %      [modes.Test3, modes.Test3low, modes.Test3high]=bootstrapmode(BTest3Var,options.bootstrapn,0.95); 
    toc

     %Calculate descriptive stats (for the medians of each ant)
    %NB This OVERWRITES the medians for the entire dataset so do NOT run this
    %section if you are making histograms etc with the full dataset
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %CALCULATE DESCRIPTIVE STATS & COM/FPM PREDICTIONS    
    %%%
    tic
    %Means %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %N.B. the existing circular mean function can return 95% CIs, but I'm not
    %sure how it's calculated. Because of this I have chosen to calculate the
    %CIs using a bootstrap function to ensure they are calculated the same way
    %as the median and mode.
    if traintype==0
     [perantmeans.stat(1), perantmeans.low(1), perantmeans.high(1), ~, perantmeans.alt(1)]=bootstrapmean(CTrainingAllVar(isnan(CTrainingAllVar)==0),options.bootstrapn,0.95); 
    else 
     [perantmeans.stat(1), perantmeans.low(1), perantmeans.high(1), ~, perantmeans.alt(1)]=bootstrapmean(CTrainingPreTestVar(isnan(CTrainingPreTestVar)==0),options.bootstrapn,0.95); 
    end  
     [perantmeans.stat(2), perantmeans.low(2), perantmeans.high(2), ~, perantmeans.alt(2)]=bootstrapmean(CTest1Var(isnan(CTest1Var)==0),options.bootstrapn,0.95); 
        if length(CTest2Var)>1
        [perantmeans.stat(3), perantmeans.low(3), perantmeans.high(3), ~, perantmeans.alt(3)]=bootstrapmean(CTest2Var(isnan(CTest2Var)==0),options.bootstrapn,0.95); 
        end
        if length(CTest3Var)>1
        [perantmeans.stat(4), perantmeans.low(4), perantmeans.high(4), ~, perantmeans.alt(4)]=bootstrapmean(CTest3Var(isnan(CTest3Var)==0),options.bootstrapn,0.95); 
        end

        %Medians %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%       
    if traintype==0
        [perantmedians.stat(1), perantmedians.low(1), perantmedians.high(1)]=circmedianIQR(CTrainingAllVar(isnan(CTrainingAllVar)==0), options.mediantype,options.quantilerange, options.medianprecision, options.IQRtype);
    else
        [perantmedians.stat(1), perantmedians.low(1), perantmedians.high(1)]=circmedianIQR(CTrainingPreTestVar(isnan(CTrainingPreTestVar)==0), options.mediantype,options.quantilerange, options.medianprecision, options.IQRtype);
    end
        [perantmedians.stat(2), perantmedians.low(2), perantmedians.high(2)]=circmedianIQR(CTest1Var(isnan(CTest1Var)==0), options.mediantype,options.quantilerange, options.medianprecision, options.IQRtype);
        if length(CTest2Var)>1
        [perantmedians.stat(3), perantmedians.low(3), perantmedians.high(3)]=circmedianIQR(CTest2Var(isnan(CTest2Var)==0), options.mediantype,options.quantilerange, options.medianprecision, options.IQRtype);
        end
         if length(CTest3Var)>1
        [perantmedians.stat(4), perantmedians.low(4), perantmedians.high(4)]=circmedianIQR(CTest3Var(isnan(CTest3Var)==0), options.mediantype,options.quantilerange, options.medianprecision, options.IQRtype);
         end
        %Medians %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%       
    if traintype==1
        [perantlinearmedians.stat(1), perantlinearmedians.low(1), perantlinearmedians.high(1)]=circmedianIQR(CTrainingAllVar(isnan(CTrainingAllVar)==0), 2,options.quantilerange, options.medianprecision, options.IQRtype);
    else
        [perantlinearmedians.stat(1), perantlinearmedians.low(1), perantlinearmedians.high(1)]=circmedianIQR(CTrainingPreTestVar(isnan(CTrainingPreTestVar)==0) ,2,options.quantilerange, options.medianprecision, options.IQRtype);
    end
        [perantlinearmedians.stat(2), perantlinearmedians.low(2), perantlinearmedians.high(2)]=circmedianIQR(CTest1Var(isnan(CTest1Var)==0),2,options.quantilerange, options.medianprecision, options.IQRtype);
        if length(CTest2Var)>1
        [perantlinearmedians.stat(3), perantlinearmedians.low(3), perantlinearmedians.high(3)]=circmedianIQR(CTest2Var(isnan(CTest2Var)==0),2,options.quantilerange, options.medianprecision, options.IQRtype);
        end
         if length(CTest3Var)>1
        [perantlinearmedians.stat(4), perantlinearmedians.low(4), perantlinearmedians.high(4)]=circmedianIQR(CTest3Var(isnan(CTest3Var)==0),2,options.quantilerange, options.medianprecision, options.IQRtype);
         end
    %      [modes.Test3, modes.Test3low, modes.Test3high]=bootstrapmode(BTest3Var,options.bootstrapn,0.95); 
    toc

    
    
    
%% Save dataset
if isfolder(savedir)==0
    mkdir(savedir);
end
cd(savedir);
    if datatype==1
        dt='PH';
    elseif datatype==2
        dt='EP';
    elseif datatype==3
        dt='E';
    elseif datatype==4
        dt='P';
    end
    if varfoodorpattern==1
        vfp='Food';
    else
        vfp='Pattern';
    end
    if turndirection==0
        td='LTurns';
    elseif turndirection==1
        td='RTurns';
    elseif turndirection==3
        td='AllTurns';
    end
    if isempty(turnstartregion)==1
        tsr='';
    else
           if turnstartregion(1)>=0
               le=['Plus' num2str(turnstartregion(1))];
           else
               le=['Minus' num2str(abs(turnstartregion(1)))];
           end
           if turnstartregion(2)>=0
               re=['Plus' num2str(turnstartregion(2))];
           else
               re=['Minus' num2str(abs(turnstartregion(2)))];
           end
           if turnselectiontype==1
            tsr=['StartRegionL' le '-R'  re];
           elseif turnselectiontype==2
            tsr=['StartRegion' le '-'  re]; 
           elseif turnselectiontype==3
            tsr=['StartRegionPatMatch' le '-PatMatch'  re];
           elseif turnselectiontype==4
            tsr=['StartRegionCoM' le '-CoM'  re];
           end
       if startfoodorpattern==1 
           tsr=[tsr 'Food'];
       else
           tsr=[tsr 'Pattern'];
       end
        
    end
    md=['Dist' num2str(maxdist) 'cm'];

savename=['D_' datestr(date, 'yymmdd') '_' dt '_' vfp '_'  td '_' tsr '_' md];
save(savename, 'B*', 'C*', 'D*', 'means', 'medians', 'linearmedians', 'perantmeans', 'perantmedians', 'perantlinearmedians', 'perrunmeans', 'perrunmedians', 'perrunlinearmedians')
end %if refinedataset==1


%% ANALYSIS
%Name dataset
    if datatype==1
        dt='Path headings';
    elseif datatype==2
        dt='Extrema + Plateaux end points';
    elseif datatype==3
        dt='Extrema end points';
    elseif datatype==4
        dt='Plateaux end points';
    end
    if varfoodorpattern==1
        vfp='relative to Food';
    else
        vfp='relative  to Pattern';
    end
    
    if turndirection==0
        td='Left turns only';
    elseif turndirection==1
        td='Right turns only';
    elseif turndirection==3
        td='Left and Right turns';
    end
    if isempty(turnstartregion)==1
        tsr='starting anywhere';
    else
           if turnstartregion(1)>=0
               le=['-plus-' num2str(turnstartregion(1))  '-degrees'];
           else
               le=['-minus-' num2str(abs(turnstartregion(1)))  '-degrees'];
           end
           if turnstartregion(2)>=0
               re=['-plus-' num2str(turnstartregion(2))  '-degrees'];
           else
               re=['-minus-' num2str(abs(turnstartregion(2)))  '-degrees'];
           end
          if turnselectiontype==1
           tsr=['starting in region from  Left-edge' le ' to Right-edge'  re];
          elseif turnselectiontype==2
           tsr=['starting in region from  zero' le ' to zero'  re];
          elseif turnselectiontype==3
           tsr=['starting in region from pattern-matching-prediction' le ' to pattern-matching-prediction'  re];
          elseif turnselectiontype==4
           tsr=['starting in region from  CoM-of-pattern' le ' to CoM-of-pattern'  re];
          end %if turnselectiontype==1
       if startfoodorpattern==1 
           tsr=[tsr ', relative to Food'];
       else
           tsr=[tsr ', relative to Pattern'];
       end
       if isempty(headstartregion)==0
               if headstartregion(1,1)>=0
                   hle=['-plus-' num2str(headstartregion(1,1))  '-degrees'];
               else
                   hle=['-minus-' num2str(abs(headstartregion(1,1)))  '-degrees'];
               end
               if headstartregion(1,2)>=0
                   hre=['-plus-' num2str(headstartregion(1,2))  '-degrees'];
               else
                   hre=['-minus-' num2str(abs(headstartregion(1,2)))  '-degrees'];
               end
          tsr=[tsr ', PLUS overall heading between ' hle ' and ' hre]; 
       end
        
    end
    md=['up to ' num2str(maxdist) 'cm from center of arena'];
    if perant==0
        if datatype==1
            pa='One datapoint per run';
        else
            pa='One datapoint per turn';
        end
    elseif perant==1
      pa='One datapoint per ant'; 
    elseif perant==2
      pa='One datapoint per run';  
    end
datatitle=['Data are: ' dt ',  ' vfp '; ' td ', ' tsr ', ' md '; ' pa];

%% Get info on which tests to run
if isempty(turnstartregion)==1
    rt=runtests(:, testtype+1);
else
    rt=runtests(:, testtype+5);
end

%% Choose data for analysis
testind=testtype+1;
if perant==0 %1 dp per run, or per turn
    if testtype==0
        if traintype==0
            testdata=BTrainingAllVar;
            testantid=BTrainingAllAntIDNo;
            testrunno=BTrainingAllRunNo;
            testsinuosity=BTrainingAllSinuosity;
            teststartvar=BTrainingAllStartVar;
            testturnamplitude=BTrainingAllTurnAmplitude;
            testturndirection=BTrainingAllTurnDirection;
            testheading=BTrainingAllHeading;
        else
            testdata=BTrainingPreTestVar;
            testantid=BTrainingPreTestAntIDNo;
            testrunno=BTrainingPreTestRunNo;
            testsinuosity=BTrainingPreTestSinuosity;
            teststartvar=BTrainingPreTestStartVar;
            testturnamplitude=BTrainingPreTestTurnAmplitude;
            testturndirection=BTrainingPreTestTurnDirection;
            testheading=BTrainingPreTestHeading;
        end %if traintype==0
    elseif testtype==1
        testdata=BTest1Var;
        testantid=BTest1AntIDNo;
        testrunno=BTest1RunNo;
        testsinuosity=BTest1Sinuosity;
        teststartvar=BTest1StartVar;
        testturnamplitude=BTest1TurnAmplitude;
        testturndirection=BTest1TurnDirection;
        testheading=BTest1Heading;
    elseif testtype==2
        testdata=BTest2Var;
        testantid=BTest2AntIDNo;
        testrunno=BTest2RunNo;
        testsinuosity=BTest2Sinuosity;
        teststartvar=BTest2StartVar;
        testturnamplitude=BTest2TurnAmplitude;
        testturndirection=BTest2TurnDirection;
        testheading=BTest2Heading;
    elseif testtype==3
        testdata=BTest3Var;
        testantid=BTest3AntIDNo;
        testrunno=BTest3RunNo;
        testsinuosity=BTest3Sinuosity;
        teststartvar=BTest3StartVar;
        testturnamplitude=BTest3TurnAmplitude;
        testturndirection=BTest3TurnDirection;
        testheading=BTest3Heading;
    end %if testtype==0
    
    if traintype==0
        traindata=BTrainingAllVar;
        trainantid=BTrainingAllAntIDNo;
        trainrunno=BTrainingAllRunNo;
        trainsinuosity=BTrainingAllSinuosity;
        trainstartvar=BTrainingAllStartVar;
        trainturnamplitude=BTrainingAllTurnAmplitude;
        trainturndirection=BTrainingAllTurnDirection;
        trainheading=BTrainingAllHeading;
    else
        traindata=BTrainingPreTestVar;
        trainantid=BTrainingPreTestAntIDNo;
        trainrunno=BTrainingPreTestRunNo;
        trainsinuosity=BTrainingPreTestSinuosity;
        trainstartvar=BTrainingPreTestStartVar;
        trainturnamplitude=BTrainingPreTestTurnAmplitude;
        trainturndirection=BTrainingPreTestTurnDirection;
        trainheading=BTrainingPreTestHeading;
    end

    meandata=means;
    if linearmed==0
        mediandata=medians;
    else
        mediandata=linearmedians;
    end
elseif perant==1 %1 dp per ant, medians of every run/turn by each unique ant
    if testtype==0
        if traintype==0
            testdata=CTrainingAllVar;
            testantid=CTrainingAllAntIDNo;
            testrunno=NaN*zeros(size(testdata));
            testsinuosity=CTrainingAllSinuosity;
            teststartvar=CTrainingAllStartVar;
            testturnamplitude=CTrainingAllTurnAmplitude;
            testturndirection=CTrainingAllTurnDirection;
            testheading=CTrainingAllHeading;
        else
            testdata=CTrainingPreTestVar;
            testantid=CTrainingPreTestAntIDNo;
            testrunno=NaN*zeros(size(testdata));
            testsinuosity=CTrainingPreTestSinuosity;
            teststartvar=CTrainingPreTestStartVar;
            testturnamplitude=CTrainingPreTestTurnAmplitude;
            testturndirection=CTrainingPreTestTurnDirection;
            testheading=CTrainingPreTestHeading;
        end %if traintype==0
    elseif testtype==1
        testdata=CTest1Var;
        testantid=CTest1AntIDNo;
        testrunno=NaN*zeros(size(testdata));
        testsinuosity=CTest1Sinuosity;
        teststartvar=CTest1StartVar;
        testturnamplitude=CTest1TurnAmplitude;
        testturndirection=CTest1TurnDirection;
        testheading=CTest1Heading;
    elseif testtype==2
        testdata=CTest2Var;
        testantid=CTest2AntIDNo;
        testrunno=NaN*zeros(size(testdata));
        testsinuosity=CTest2Sinuosity;
        teststartvar=CTest2StartVar;
        testturnamplitude=CTest2TurnAmplitude;
        testturndirection=CTest2TurnDirection;
        testheading=CTest2Heading;
    elseif testtype==3
        testdata=CTest3Var;
        testantid=CTest3AntIDNo;
        testrunno=NaN*zeros(size(testdata));
        testsinuosity=CTest3Sinuosity;
        teststartvar=CTest3StartVar;
        testturnamplitude=CTest3TurnAmplitude;
        testturndirection=CTest3TurnDirection;
        testheading=CTest3Heading;
    end %if testtype==0
    
    if traintype==0
        traindata=CTrainingAllVar;
        trainantid=CTrainingAllAntIDNo;
        trainrunno=NaN*zeros(size(traindata));
        trainsinuosity=CTrainingAllSinuosity;
        trainstartvar=CTrainingAllStartVar;
        trainturnamplitude=CTrainingAllTurnAmplitude;
        trainturndirection=CTrainingAllTurnDirection;
        trainheading=CTrainingAllHeading;
    else
        traindata=CTrainingPreTestVar;
        trainantid=CTrainingPreTestAntIDNo;
        trainrunno=NaN*zeros(size(traindata));
        trainsinuosity=CTrainingPreTestSinuosity;
        trainstartvar=CTrainingPreTestStartVar;
        trainturnamplitude=CTrainingPreTestTurnAmplitude;
        trainturndirection=CTrainingPreTestTurnDirection;
        trainheading=CTrainingPreTestHeading;
    end
    
    %Ensure we only compare ants that have a dp for both test and train
    [~,commonantstrain,commonantstest]=intersect(trainantid, testantid, 'rows');
        traindata=traindata(commonantstrain);
        trainantid=trainantid(commonantstrain);
        trainrunno=trainrunno(commonantstrain);
        trainsinuosity=trainsinuosity(commonantstrain);
        trainstartvar=trainstartvar(commonantstrain);
        trainturnamplitude=trainturnamplitude(commonantstrain);
        trainturndirection=trainturndirection(commonantstrain);
        trainheading=trainheading(commonantstrain);
        
        testdata=testdata(commonantstest);
        testantid=testantid(commonantstest);
        testrunno=testrunno(commonantstest);
        testsinuosity=testsinuosity(commonantstest);
        teststartvar=teststartvar(commonantstest);
        testturnamplitude=testturnamplitude(commonantstest);
        testturndirection=testturndirection(commonantstest);
        testheading=testheading(commonantstest);

    meandata=perantmeans;
    if linearmed==0
        mediandata=perantmedians;
    else
        mediandata=perantlinearmedians;
    end
elseif perant==2 %1 dp per run, medians of every turn in each unique ant/run
    if testtype==0
        if traintype==0
            testdata=DTrainingAllVar;
            testantid=DTrainingAllAntIDNo;
            testrunno=DTrainingAllRunNo;
            testsinuosity=DTrainingAllSinuosity;
            teststartvar=DTrainingAllStartVar;
            testturnamplitude=DTrainingAllTurnAmplitude;
            testturndirection=DTrainingAllTurnDirection;
            testheading=DTrainingAllHeading;
        else
            testdata=DTrainingPreTestVar;
            testantid=DTrainingPreTestAntIDNo;
            testrunno=DTrainingPreTestRunNo;
            testsinuosity=DTrainingPreTestSinuosity;
            teststartvar=DTrainingPreTestStartVar;
            testturnamplitude=DTrainingPreTestTurnAmplitude;
            testturndirection=DTrainingPreTestTurnDirection;
            testheading=DTrainingPreTestHeading;
        end %if traintype==0
    elseif testtype==1
        testdata=DTest1Var;
        testantid=DTest1AntIDNo;
        testrunno=DTest1RunNo;
        testsinuosity=DTest1Sinuosity;        
        teststartvar=DTest1StartVar;
        testturnamplitude=DTest1TurnAmplitude;
        testturndirection=DTest1TurnDirection;
        testheading=DTest1Heading;
    elseif testtype==2
        testdata=DTest2Var;
        testantid=DTest2AntIDNo;
        testrunno=DTest2RunNo;
        testsinuosity=DTest1Sinuosity;
        teststartvar=DTest2StartVar;
        testturnamplitude=DTest2TurnAmplitude;
        testturndirection=DTest2TurnDirection;
        testheading=DTest2Heading;
    elseif testtype==3
        testdata=DTest3Var;
        testantid=DTest3AntIDNo;
        testrunno=DTest3RunNo;
        testsinuosity=DTest1Sinuosity;
        teststartvar=DTest3StartVar;
        testturnamplitude=DTest3TurnAmplitude;
        testturndirection=DTest3TurnDirection;
        testheading=DTest3Heading;
    end %if testtype==0
    
    if traintype==0
        traindata=DTrainingAllVar;
        trainantid=DTrainingAllAntIDNo;
        trainrunno=DTrainingAllRunNo;
        trainsinuosity=DTrainingAllSinuosity;
        trainstartvar=DTrainingAllStartVar;
        trainturnamplitude=DTrainingAllTurnAmplitude;
        trainturndirection=DTrainingAllTurnDirection;
        trainheading=DTrainingAllHeading;
    else
        traindata=DTrainingPreTestVar;
        trainantid=DTrainingPreTestAntIDNo;
        trainrunno=DTrainingPreTestRunNo;
        trainsinuosity=DTrainingPreTestSinuosity;
        trainstartvar=DTrainingPreTestStartVar;
        trainturnamplitude=DTrainingPreTestTurnAmplitude;
        trainturndirection=DTrainingPreTestTurnDirection;
        trainheading=DTrainingPreTestHeading;
    end
    
%     %Ensure we only compare ants that have a dp for both test and train
%     [~,commonantstrain,commonantstest]=intersect(trainantid, testantid, 'rows');
%         traindata=traindata(commonantstrain);
%         trainantid=trainantid(commonantstrain);
%         trainrunno=trainrunno(commonantstrain);
%         
%         testdata=testdata(commonantstest);
%         testantid=testantid(commonantstest);
%         testrunno=testrunno(commonantstest);
        
    meandata=perrunmeans;
    if linearmed==0
        mediandata=perrunmedians;
    else
        mediandata=perrunlinearmedians;
    end
end %if perant==0

%Get per ant sinuosity %%%%%%%%%%%%%%%%%%%%%%%%%%
    if testtype==0
        if traintype==0
            patestantid=CTrainingAllAntIDNo;
            patestsinuosity=CTrainingAllSinuosity;
        else
            patestantid=CTrainingPreTestAntIDNo;
            patestsinuosity=CTrainingPreTestSinuosity;
        end %if traintype==0
    elseif testtype==1
        patestantid=CTest1AntIDNo;
        patestsinuosity=CTest1Sinuosity;
    elseif testtype==2
        patestantid=CTest2AntIDNo;
        patestsinuosity=CTest2Sinuosity;
    elseif testtype==3
        patestantid=CTest3AntIDNo;
        patestsinuosity=CTest3Sinuosity;
    end %if testtype==0
    
    if traintype==0
        patrainantid=CTrainingAllAntIDNo;
        patrainsinuosity=CTrainingAllSinuosity;
    else
        patrainantid=CTrainingPreTestAntIDNo;
        patrainsinuosity=CTrainingPreTestSinuosity;
    end
    
    %Ensure we only compare ants that have a dp for both test and train
    [~,commonantstrain,commonantstest]=intersect(patrainantid, patestantid, 'rows');
        patrainsinuosity=patrainsinuosity(commonantstrain);
        patestsinuosity=patestsinuosity(commonantstest);
%%%%%%%%%%%%%%%%%%%%%%%%5

%Get pattern prediction
    patternmatch=predictions.edgematches(testtype+1);
%Rotate data to match pattern prediction
    traindatarotated=ModAnglesJLWv2(traindata-patternmatch);
    testdatarotated=ModAnglesJLWv2(testdata-patternmatch);
    teststartvarrotated=ModAnglesJLWv2(teststartvar-patternmatch);
    trainstartvarrotated=ModAnglesJLWv2(trainstartvar-patternmatch);
    testheadingrotated=ModAnglesJLWv2(testheading-patternmatch);
    trainheadingrotated=ModAnglesJLWv2(trainheading-patternmatch);
    [testmedianrotated, ~, ~]=circmedianIQR(testdatarotated, options.mediantype,options.quantilerange, options.medianprecision, options.IQRtype);
    [testmeanrotated, ~, ~, ~, ~]=bootstrapmean(testdatarotated,options.bootstrapn,0.95); 

if turndirection==3 | turndirection==1 | weirdleftthing==0%Right turns or all turns - test the predictions that the ants are heading towards channel- or pattern-defined goals
    cgoal=0;
    pgoal=patternmatch;
    if whatdata==1
    cname='Channel-defined goal';
    pname='Pattern-matching goal';
    elseif whatdata==2
    cname='Right-edge-matching goal'; 
    pname='CoM-matching goal';
    end
elseif weirdleftthing==1 & turndirection==0 %If we are looking at left turns only, test the prediction that ants are geading toeard the right edge or CoM of the pattern
    cgoal=predge(testtype+1);
    pgoal=predge(testtype+1)+((pledge(testtype+1)-predge(testtype+1))/2); %pattern CoM
    cname='Right-edge of pattern';
    pname='CoM of pattern';
end

%% Make histogram
if plothist==1
    figsummary=cellstr({});
        Acount=length(unique(testantid));
       figsummary=[figsummary; cellstr(['A: ' num2str(Acount)])];
        if perant~=1
         Pcount=B_P(testtype+1);
        figsummary=[figsummary; cellstr(['P: ' num2str(Pcount)])];
        end
        if perant==0 & datatype~=1
         Ecount=B_E(testtype+1);
        figsummary=[figsummary; cellstr(['E: ' num2str(Ecount)])];
        end
        figsummary=[figsummary; cellstr('')];
                
        if avetype==2
         avedata=[mediandata.stat(testtype+1), mediandata.low(testtype+1), mediandata.high(testtype+1)];
% figsummary=[figsummary; cellstr(['Median = ' num2str(avedata(1))])];
%         figsummary=[figsummary; cellstr(['IQR = ' num2str(avedata(2))  ' : ' num2str(avedata(3))])];
%         figsummary=[figsummary; cellstr('')];
           
        elseif avetype==1
         avedata=[meandata.stat(testtype+1), meandata.low(testtype+1), meandata.high(testtype+1)];
%         figsummary=[figsummary; cellstr(['Mean = ' num2str(avedata(1))])];
%         figsummary=[figsummary; cellstr(['95% CI = ' num2str(avedata(2))  ' : ' num2str(avedata(3))])];
%         figsummary=[figsummary; cellstr('')];
            %If plotting means and CIs, we also make another figure with
            %the median data which can be swapped in later if required
         backupavedata=[mediandata.stat(testtype+1), mediandata.low(testtype+1), mediandata.high(testtype+1)];
        end

if whatdata==1
         edgematch=patternmatch;
         channelmatch=0; %ONEY experiments
elseif whatdata==2
        %For RSS0 also plot CoM of pattern
         edgematch=[predge(testtype+1)+((pledge(testtype+1)-predge(testtype+1))/2), patternmatch]; %1st is CoM of pattern; 2nd id CoM-matching prediction 
         channelmatch=[0, predictions.lmatches(testtype+1)]; %RSS0 experiments: note these are actually the edge matching predictions, since there was no channel
end %if whatdata         
        %Histograms %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        patternfigheight= 375;
        patternfigwidth= 675;           
        figposition=[9 160 patternfigwidth   patternfigheight];
        figtitle=[];
        
        %Make 1 histogram for each specified binsize
        for binind=1:length(options.binsize)
        %AXIS LIMITS AND BIN SIZES
        %calculate axis limits. There are 2 issues: the first is to ensure that
        %histograms and other plots all use identical axes, so we need to adjust
        %the axis limits to ensure the histogram bins fit. if there are multiple
        %hist bins, we use the first set to standardise everything. Other
        %histograms will fall slightly off the edge of the axes but we'll have to
        %live with that. Issue 2 is to ensure that the axis all go from positive to
        %negative. This means that if for some reason you have chosen to have the
        %axes cross 180d we will have to rename part of the axis (and remember to fix the data, below)
        %Make any changes to ensure axis decreases
                xmin=-180;
                xmax=180;
                hbins.h=[fliplr([0-(options.binsize(binind)/2):-options.binsize(binind):xmin]),[0+(options.binsize(binind)/2):options.binsize(binind):xmax+(options.binsize(binind)/2)]];
%             hbins.h=xmin+(options.binsize(binind)/2):options.binsize(binind):xmax;
           %correct axis start and end to allow histogram bins to fit
            xmin=hbins.h(1);%-(options.binsize(binind)/2);
            xmax=hbins.h(end);%+(options.binsize(binind)/2);
        
    %Make fig        
        figcreatorhistv200530(testdata,hbins.h,xmin,xmax,figposition,figtitle, avedata, predge(testtype+1), pledge(testtype+1), edgematch, channelmatch)  ;
        %figcreatorhistv  ' num2str(BTrainingAllAnt_A) ; 'P: ' num2str(BTrainingAllAnt_P)]);
        
            xl=get(gca,'XLim'); yl=get(gca,'YLim');
        summarytext=text(0.95*xl(2),0.75*yl(2), figsummary);
        end % for binind=1:length(options.binsize)
        
%         %Make secondary bar at top, showingthe median and IQR
%         if avetype==1
%             avebarcreatorhistv201024(testdata,hbins.h,xmin,xmax,figposition,figtitle,backupavedata) 
%         end
        
        
end %if plothist==1

% %% Plot figure showing where goal-facing turns originate
% if rt(20)==1 & datatype>1
% binind=1;
%         %AXIS LIMITS AND BIN SIZES
%                 xmin=-180;
%                 xmax=180;
%                 hbins.h=[fliplr([0-(options.binsize(binind)/2):-options.binsize(binind):xmin]),[0+(options.binsize(binind)/2):options.binsize(binind):xmax+(options.binsize(binind)/2)]];
% %             hbins.h=xmin+(options.binsize(binind)/2):options.binsize(binind):xmax;
%            %correct axis start and end to allow histogram bins to fit
%             xmin=hbins.h(1);%-(options.binsize(binind)/2);
%             xmax=hbins.h(end);%+(options.binsize(binind)/2);
% if whatdata==1
%             goalbinsize=10;
%      turnstartendfigmeans=Turnstartendfigmaker(teststartvar, testdata, goalbinsize, edgematch, channelmatch, [], hbins.h,xmin,xmax,figposition,predge(testtype+1), pledge(testtype+1)); %pattern match
%      turnstartendfigall=Turnstartendfigmaker(teststartvar, testdata, goalbinsize, channelmatch,  edgematch,[], hbins.h,xmin,xmax,figposition,predge(testtype+1), pledge(testtype+1)); %channel match
% 
%      goalbinsize=20;
%      turnstartendfigmeans=Turnstartendfigmaker(teststartvar, testdata, goalbinsize, edgematch, channelmatch, [], hbins.h,xmin,xmax,figposition,predge(testtype+1), pledge(testtype+1)); %pattern match
%      turnstartendfigall=Turnstartendfigmaker(teststartvar, testdata, goalbinsize, channelmatch,  edgematch,[], hbins.h,xmin,xmax,figposition,predge(testtype+1), pledge(testtype+1)); %channel match
% 
% elseif whatdata==2
%             goalbinsize=10;
%      turnstartendfigmeans=Turnstartendfigmaker(teststartvar, testdata, goalbinsize, edgematch(2), channelmatch(:), [], hbins.h,xmin,xmax,figposition,predge(testtype+1), pledge(testtype+1)); %pattern match
%             goalbinsize=20;
%      turnstartendfigmeans=Turnstartendfigmaker(teststartvar, testdata, goalbinsize, edgematch(2), channelmatch(:), [], hbins.h,xmin,xmax,figposition,predge(testtype+1), pledge(testtype+1)); %pattern match
% 
%      turnstartendfigall=Turnstartendfigmaker(teststartvar, testdata, goalbinsize, channelmatch(:),  edgematch(2),[], hbins.h,xmin,xmax,figposition,predge(testtype+1), pledge(testtype+1)); %channel match
% end %if whatdata
% end%if turnstartend==1

%% Plot correlation: path heading vs end-points
plotwayround=2; %1=endpoints vs heading; 2=heading vs endpoints

if rt(21)==1 & datatype>1
    if plotwayround==1
        corrx=testdata;
        corry=testheading;
    elseif plotwayround==2
        corrx=testheading;
        corry=testdata;
    end
groupid=(100*testantid)+testheading; %create a unique id for each ant-run
%mean end point
turncorrelationfig=Turncorrelationfigmaker(corrx, corry, groupid, hbins.h,xmin,xmax,[figposition(1) 0 figposition(3) figposition(3)],predge(testtype+1), pledge(testtype+1), edgematch, channelmatch);
turncorrelationfig=Turncorrelationfigmaker2(corrx, corry, groupid, hbins.h,-180,180,[9.0000  45.000  675   641.6],predge(testtype+1), pledge(testtype+1), edgematch, channelmatch);

% % %all end points
% turncorrelationfig=Turncorrelationfigmaker(corrx, corry,[], hbins.h,xmin,xmax,[figposition(1) 0 figposition(3) figposition(3)],predge(testtype+1), pledge(testtype+1), edgematch, channelmatch);
end
% %% Plot distribution of discrepancy between path heading and endpoints
% if rt(26)==1  & datatype>1
%       groupid=[];
% % turnvheadviolin=Turnvsheadingfigmaker(testdata, testheading, groupid, hbins.h,xmin,xmax,figposition);
% turnvheadhist=Turnvsheadinghistogrammaker(testdata, testheading, groupid, hbins.h,xmin,xmax,figposition, []);
%     groupid=(100*testantid)+testheading; %create a unique id for each ant-run
% turnvheadhist=Turnvsheadinghistogrammaker(testdata, testheading, groupid, hbins.h,xmin,xmax,figposition, []);
% 
% end

% %% Violin plots
% if rt(23)==1 & datatype>1
%     for binind=1:length(options.binsize)
%             %AXIS LIMITS AND BIN SIZES
%                     xmin=-180;
%                     xmax=180;
%                     hbins.h=[fliplr([0-(options.binsize(binind)/2):-options.binsize(binind):xmin]),[0+(options.binsize(binind)/2):options.binsize(binind):xmax+(options.binsize(binind)/2)]];
%     %             hbins.h=xmin+(options.binsize(binind)/2):options.binsize(binind):xmax;
%                %correct axis start and end to allow histogram bins to fit
%                 xmin=hbins.h(1);%-(options.binsize(binind)/2);
%                 xmax=hbins.h(end);%+(options.binsize(binind)/2);
%                 yticklocations=-180:60:180;
%                 %%
% %y=turn endpoint,binned by path heading
%     figtitle='X: binned path heading; Y: turn end-points';
%     violinbinnedfig=Violinbinnedfigmaker(testheading, testdata, hbins.h,xmin,xmax,figposition,patternredge, patternledge, edgematch, channelmatch, yticklocations, figtitle);
% %%
%     %y=size of turn,binned by path heading
%     figtitle='X: binned path heading; Y: turn size';
%     violinbinnedfig=Violinbinnedfigmaker(testheading, testturnamplitude, hbins.h,xmin,xmax,figposition,patternredge, patternledge, edgematch, channelmatch, yticklocations, figtitle);
% 
% 
% %y=discrepancy between turn endpoint and pattern goal ,binned by discrepancy between path heading and patterngoal
%     figtitle='X: path heading relative to pattern goal; Y: turn end-point relative to pattern goal';
%     violinbinnedfig=Violinbinnedfigmaker(angdiff(testheading, pgoal,'ang', 'directional'), angdiff(testdata, pgoal, 'ang', 'directional'), hbins.h,xmin,xmax,figposition,patternredge, patternledge, edgematch, channelmatch, yticklocations, figtitle);
% %y=size of turn ,binned by discrepancy between path heading and patterngoal
%     figtitle='X: path heading relative to pattern goal; Y: turn size';
%     violinbinnedfig=Violinbinnedfigmaker(angdiff(testdata, pgoal,  'ang', 'directional'),testturnamplitude,  hbins.h,xmin,xmax,figposition,patternredge, patternledge, edgematch, channelmatch, yticklocations, figtitle);
% 
% %y=size of turn ,binned by discrepancy between path heading and turn
% %endpoint
%     figtitle='X: turn end-point relative to overall path heading; Y: turn size';
%     violinbinnedfig=Violinbinnedfigmaker(angdiff(testdata, testheading,  'ang', 'directional'),testturnamplitude,  hbins.h,xmin,xmax,figposition,patternredge, patternledge, edgematch, channelmatch, yticklocations, figtitle);
% 
% %y=size of turn ,binned by discrepancy between path heading and turn
% %strtpoint
%     figtitle='X: turn start-point relative to overall path heading; Y: turn size';
%     violinbinnedfig=Violinbinnedfigmaker(angdiff(teststartvar, testheading, 'ang', 'directional'),testturnamplitude,  hbins.h,xmin,xmax,figposition,patternredge, patternledge, edgematch, channelmatch, yticklocations, figtitle);
% %%
%  figure   
%     figtitle='X: L or R turn; Y: turn end-point relative to pattern goal';
% vs=violinplot(angdiff(testdata, pgoal,  'ang', 'directional'), testturndirection, 'ViolinColor', [0.7 0.7 0.7], 'ShowData', logical(0), 'ShowMean', logical(1), 'EdgeColor', [0 0 0], 'ViolinAlpha', 0.5, 'BoxColor', [0.3 0.3 0.3]);
% title(figtitle);
% 
% figure
%     figtitle='X: L or R turn; Y: turn end-point relative to channel goal';
% 
% vs=violinplot(angdiff(testdata, cgoal,  'ang', 'directional'), testturndirection, 'ViolinColor', [0.7 0.7 0.7], 'ShowData', logical(0), 'ShowMean', logical(1), 'EdgeColor', [0 0 0], 'ViolinAlpha', 0.5, 'BoxColor', [0.3 0.3 0.3]);
% title(figtitle);
% 
%     end
% end
%% Stats
% Make blank summary string
summary=cellstr({});

% Summary stats
if testtype==0 & traintype==0
    summary=[summary; cellstr(['Training data: all runs'])];
elseif testtype==0
    summary=[summary; cellstr(['Training data: pre-test runs only'])];
else
    summary=[summary; cellstr(['Test ' num2str(testtype) ' data'])];
end
summary=[summary; cellstr(datatitle)];
summary=[summary; cellstr('')];

%Ns
        Acount=length(unique(testantid));
       summary=[summary; cellstr(['A (N Ants): ' num2str(Acount)])];
        if perant~=1
         Pcount=B_P(testtype+1);
       summary=[summary; cellstr(['P (N Paths):' num2str(Pcount)])];
        end
        if perant==0 & datatype~=1
         Ecount=B_E(testtype+1);
         if datatype==2%1=path headings, 2=Extrema+Plateaux, 3=Extrema, 4=Plateaux
        summary=[summary; cellstr(['E (N combined Extrema + Plateaux): ' num2str(Ecount)])];
         elseif datatype==3
        summary=[summary; cellstr(['E (N Extrema): ' num2str(Ecount)])];
         elseif datatype==4
        summary=[summary; cellstr(['E (N Plateaux end-points): ' num2str(Ecount)])];
         else
        summary=[summary; cellstr(['E (N Turn end-points): ' num2str(Ecount)])];     
         end
        end %if perant==0 & datatype~=1
        summary=[summary; cellstr('')];

%descriptives
summary=[summary; cellstr(['Median = ' num2str(mediandata.stat(testtype+1)) '; IQR = '  num2str(mediandata.low(testtype+1)) ' : ' num2str(mediandata.high(testtype+1))])];
summary=[summary; cellstr(['Mean = ' num2str(meandata.stat(testtype+1)) '; 95% CI = ' num2str(meandata.low(testtype+1))  ' : ' num2str(meandata.high(testtype+1))])];
summary=[summary; cellstr([cname ' is ' num2str(cgoal)])];
summary=[summary; cellstr([pname ' is ' num2str(pgoal)])];
summary=[summary; cellstr('')];
summary=[summary; cellstr(['Mean sinuosity: ' num2str(nanmean(testsinuosity)) '; SE: ' num2str((std(testsinuosity))/(sqrt(length(testsinuosity))))])];
summary=[summary; cellstr('')];


%% %% Test 1: Rayleigh test
if rt(1)==1
    %Rayleigh test for uniformity
        [pr, zr]=circ_rtest(ang2rad(testdata));
    summary=[summary; cellstr('_ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _')];
    summary=[summary; cellstr('Does the data show a peak or is it uniformly distributed?')];
    summary=[summary; cellstr('Rayleigh test for uniformity:')];
    summary=[summary; cellstr(['Z: ' num2str(zr)])];
    if pr>0.0001
    summary=[summary; cellstr(['P: ' num2str(pr)])];
    else
      summary=[summary; cellstr(['P < 0.0001'])];  
    end
    if pr<0.05
    summary=[summary; cellstr('Data is NOT uniformly distributed.')];
    else
    summary=[summary; cellstr('Data IS uniformly distributed around circle.')];
    end
    summary=[summary; cellstr('')];
end

%% Test 19: Hartigan's dip test
if rt(19)==1
    %Unwrap circular data opposite mean
    thetmean=rad2ang(circ_mean(ang2rad(testdata)));
    cutpt=ModAnglesJLWv2(thetmean+180);
    orderedthet=testdata;
    orderedthet(orderedthet>cutpt)=orderedthet(orderedthet>cutpt)-360;
    orderedthet(orderedthet<cutpt)=orderedthet(orderedthet<cutpt)+360;
    orderedthet= sort(orderedthet,'descend') ;
    [dip, p_value, xlow,xup]=HartigansDipSignifTest(orderedthet,10000);
    if xlow<-180
        xlow=xlow+360;
    end
    if xlow>180
        xlow=xlow-360;
    end
    if xup<-180
        xup=xup+360;
    end
    if xup>180
        xup=xup-360;
    end
    
    summary=[summary; cellstr('Hartigan''s Dip Test for unimodality :')];
    summary=[summary; cellstr(['Dip Statistic: ' num2str(dip)])];
    if p_value>0.0001
    summary=[summary; cellstr(['P: ' num2str(p_value)])];
    else
      summary=[summary; cellstr(['P < 0.0001'])];  
    end
    if p_value<0.05
    summary=[summary; cellstr('Data is NOT unimodal.')];
    else
    summary=[summary; cellstr('Data IS unimodal.')];
    summary=[summary; cellstr(['Confidence interval for mode = ' num2str(xlow) ' : ' num2str(xup)])];
    end
    summary=[summary; cellstr('')];
end

%% Compare distribution to 0 (channel-defined goal)
if any(rt([2;4;13; 30; 32])==1)
    summary=[summary; cellstr('_ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _')];
    summary=[summary; cellstr(['Is test data significantly different to ' cname '?'])];
    summary=[summary; cellstr('')];
end

%%  Test 2: circ_medtest, H0=0
%circ_medtest to compare median of observed distribution to the expected
%median if ants use channel-defined goal
if rt(2)==1
    [pval] = circ_medtest(ang2rad(testdata),ang2rad(cgoal));
    summary=[summary; cellstr(['Binomial test (Zar JH, 1999, Biostatistical Analysis) to test whether circular median of observed distribution is different from ' cname ':'])];
    summary=[summary; cellstr(['N: ' num2str(length(testdata))])];
    if pval>0.0001
    summary=[summary; cellstr(['P: ' num2str(pval)])];
    else
      summary=[summary; cellstr(['P < 0.0001'])];  
    end
    if pval>0.05
    summary=[summary; cellstr(['NO significant difference between ' cname ' and circular median of observed facing directions.'])];
    else
    summary=[summary; cellstr(['Circular median of facing directions IS significantly different from ' cname ])]; 
    end
    summary=[summary; cellstr('')];
end %if runtests(2, testtype+1)==1

%% Test 4: circ_mtest, H0=0
%circ_mtest to compare mean of observed distribution to the expected
%mean if ants use channel-defined goal
if rt(4)==1
    [h] = circ_mtest(ang2rad(testdata),ang2rad(cgoal));
    summary=[summary; cellstr(['M-Test (Zar JH, 1999, Biostatistical Analysis) to  test whether circular mean of observed distribution is different from ' cname ':'])];
    summary=[summary; cellstr('NB, this test doesn''t return a P-value. I suspect significance is determined by whether the predicted mean falls within the 95% CI, which we have already calculated, above.')];
    summary=[summary; cellstr(['N: ' num2str(length(testdata))])];
    if h==0
    summary=[summary; cellstr('P > 0.05')];
    summary=[summary; cellstr(['NO significant difference between ' cname  ' and circular mean of observed facing directions at 0.05 level.'])];
    else
    summary=[summary; cellstr('P < 0.05')];
    summary=[summary; cellstr(['Circular mean of facing directions IS significantly different from ' cname  ' at 0.05 level.'])]; 
    end
    summary=[summary; cellstr('')];
end

%% Test 13: circ_vtest, H0=0
%circ_vtest to compare mean of observed distribution to the expected
%mean if ants use channel-defined goal
if rt(13)==1
    [pval, v] = circ_vtest(ang2rad(testdata),ang2rad(cgoal));
    summary=[summary; cellstr(['V-Test (Zar JH, 1999, Biostatistical Analysis) to  test whether observed distribution is non-uniform with mean equal to ' cname ':'])];
    summary=[summary; cellstr(['N: ' num2str(length(testdata))])];
    summary=[summary; cellstr(['V: ' num2str(v)])];
    if pval>=0.0001 & pval<=0.9999
    summary=[summary; cellstr(['P: ' num2str(pval)])];
    elseif pval<0.0001
      summary=[summary; cellstr(['P < 0.0001'])];  
    elseif pval>0.9999
      summary=[summary; cellstr(['P > 0.999'])];   
    end
    if pval>0.05
    summary=[summary; cellstr(['Either distribution is UNIFORM or it is non-uniform with a mean significantly DIFFERENT to ' cname ])];
    else
    summary=[summary; cellstr(['Distribution IS non-uniform with mean equal to ' cname])]; 
    end
    summary=[summary; cellstr('')];
end

%% Test 30: Likelihood ratio test, H0=0
%Likelihood ratio test to compare mean of observed distribution to the expected
%mean if ants use channel-defined goal
if rt(30)==1
    [pval, stat, df]=CircMeantTestJLW(ang2rad(testdata),ang2rad(cgoal), 'lr');
    summary=[summary; cellstr(['Likelihood ratio Test (Mardia & Jupp, 2000) to test whether mean of distribution differs from ' cname ':'])];
    summary=[summary; cellstr(['d.f.: ' num2str(df)])];
    summary=[summary; cellstr(['Chi-Sq: ' num2str(stat)])];
    if pval>=0.0001 & pval<=0.9999
    summary=[summary; cellstr(['P: ' num2str(pval)])];
    elseif pval<0.0001
      summary=[summary; cellstr(['P < 0.0001'])];  
    elseif pval>0.9999
      summary=[summary; cellstr(['P > 0.999'])];   
    end
    if pval>=0.05
    summary=[summary; cellstr(['NO significant difference between ' cname  ' and circular mean of observed facing directions.' ])];
    else
    summary=[summary; cellstr(['Circular mean of facing directions IS significantly different from ' cname ])]; 
    end
    summary=[summary; cellstr('')];
end

%% Test 32: Likelihood ratio test, H0=0
%Likelihood ratio test to compare mean of observed distribution to the expected
%mean if ants use channel-defined goal
if rt(32)==1
    [pval, stat, df]=CircMeantTestJLW(ang2rad(testdata),ang2rad(cgoal), 'ww');
    summary=[summary; cellstr(['Watson-Williams mean Test (Mardia & Jupp, 2000) to test whether mean of distribution differs from ' cname ':'])];
    summary=[summary; cellstr(['d.f.: ' num2str(df)])];
    summary=[summary; cellstr(['F: ' num2str(stat)])];
    if pval>=0.0001 & pval<=0.9999
    summary=[summary; cellstr(['P: ' num2str(pval)])];
    elseif pval<0.0001
      summary=[summary; cellstr(['P < 0.0001'])];  
    elseif pval>0.9999
      summary=[summary; cellstr(['P > 0.999'])];   
    end
    if pval>=0.05
    summary=[summary; cellstr(['NO significant difference between ' cname  ' and circular mean of observed facing directions.' ])];
    else
    summary=[summary; cellstr(['Circular mean of facing directions IS significantly different from ' cname ])]; 
    end
    summary=[summary; cellstr('')];
end

%% Compare distribution to training when aligned on 0 (channel-defined goal)
if any(rt([6;8;11;15])==1)
    summary=[summary; cellstr('_ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _')];
    summary=[summary; cellstr(['Is test distribution significantly different from training distribution when aligned on ' cname '?'])];
    summary=[summary; cellstr('')];
end

%% Test6: circ_cmtest, Test vs unrotated training
if rt(6)==1
    [pval, med, P] = circ_cmtest(ang2rad(testdata), ang2rad(traindata));
    summary=[summary; cellstr('Common median test (Fisher NI, 1995) to test for equal medians in two distributions (circular equivalent of Kruskal-Wallis test):')];
    summary=[summary; cellstr(['N: ' num2str(length(testdata)) ', ' num2str(length(traindata))])];
    summary=[summary; cellstr(['Common median test statistic (P): ' num2str(P)])];
    if pval>0.0001
    summary=[summary; cellstr(['P: ' num2str(pval)])];
    else
      summary=[summary; cellstr('P < 0.0001')];  
    end
    if pval>0.05
    summary=[summary; cellstr(['NO significant difference between circular medians of training and test distribution, when aligned on ' cname])];
    summary=[summary; cellstr(['Estimated shared population median: ' num2str(rad2ang(med))])];
    else
    summary=[summary; cellstr(['Circular median of test distribution IS significantly different to that of training distribution, when aligned on ' cname])]; 
    summary=[summary; cellstr(['Test median: ' num2str(mediandata.stat(testtype+1)) '; Training median: ' num2str(mediandata.stat(1))])];
    end
    summary=[summary; cellstr('')];
end

%% Test 8: circ_wwtest,  Test vs unrotated training
if rt(8)==1
    [pval, table] = circ_wwtest(ang2rad(testdata), ang2rad(traindata));
    summary=[summary; cellstr('Parametric Watson-Williams test (Zar JH, 1999, Biostatistical Analysis) to test for equal means in two distributions (circular equivalent of one-way ANOVA):')];
    summary=[summary; cellstr(['d.f.: ' num2str(table{2,2}) ', ' num2str(table{3,2})])];
    summary=[summary; cellstr(['F: ' num2str(table{2,5})])];
    if pval>0.0001
    summary=[summary; cellstr(['P: ' num2str(pval)])];
    else
      summary=[summary; cellstr('P < 0.0001')];  
    end
    if pval>0.05
    summary=[summary; cellstr(['NO significant difference between circular means of training and test distribution, when aligned on ' cname])];
    else
    summary=[summary; cellstr(['Circular mean of test distribution IS significantly different to that of training distribution, when aligned on ' cname])]; 
    end
    summary=[summary; cellstr(['Test mean: ' num2str(rad2ang(circ_mean(ang2rad(testdata)))) '; Training mean: ' num2str(meandata.stat(1))])];
    summary=[summary; cellstr('')];
end

%% Test 11: signrank, test data is difference between test and unrotated training for paired data (1dp per ant), H0=0
if rt(11)==1 & perant==1
    alpha=angdiff(testdata,traindata,'ang','directional');
    [pallintest,hallintest,statsallintest]=signrank(alpha);
    summary=[summary; cellstr('Paired test: is difference between each ant''s median facing direction in tests vs training significantly different from zero?')];
    summary=[summary; cellstr('Data for testing is each ant''s median direction in the test minus the same ant''s median direction in training. If they behave the same in the test as they did during training, this difference should be equal to zero.')];
    summary=[summary; cellstr('1-sample Wilcoxon signed rank test for zero median:')];
    summary=[summary; cellstr(['N: ' num2str(length(alpha))])];
    summary=[summary; cellstr(['Z: ' num2str(statsallintest.zval)])];
    if pallintest>0.0001
    summary=[summary; cellstr(['P: ' num2str(pallintest)])];
    else
      summary=[summary; cellstr(['P < 0.0001'])];  
    end
    if hallintest==0
    summary=[summary; cellstr(['NO significant difference between facing directions in test and training, when aligned on ' cname])];
    else
    summary=[summary; cellstr(['Facing directions ARE significantly different between test and training, when aligned on ' cname])]; 
    end
    summary=[summary; cellstr(['Median difference between treatments is: ' num2str(median(alpha)) ' degrees'])];
    summary=[summary; cellstr('')];
end

%% Test 8: circ_wwtest,  Test vs unrotated training
% if rt(8)==1
%     [pval, table] = circ_wwtest(ang2rad(testdata), ang2rad(traindata));
%     summary=[summary; cellstr('Parametric Watson-Williams test (Zar JH, 1999, Biostatistical Analysis) to test for equal means in two distributions (circular equivalent of one-way ANOVA):')];
%     summary=[summary; cellstr(['d.f.: ' num2str(table{2,2}) ', ' num2str(table{3,2})])];
%     summary=[summary; cellstr(['F: ' num2str(table{2,5})])];
%     if pval>0.0001
%     summary=[summary; cellstr(['P: ' num2str(pval)])];
%     else
%       summary=[summary; cellstr('P < 0.0001')];  
%     end
%     if pval>0.05
%     summary=[summary; cellstr('NO significant difference between circular means of training and test distribution, when aligned on channel-defined goal.')];
%     else
%     summary=[summary; cellstr('Circular mean of test distribution IS significantly different to that of training distribution, when aligned on channel-defined goal.')]; 
%     end
%     summary=[summary; cellstr(['Test mean: ' num2str(rad2ang(circ_mean(ang2rad(testdata)))) '; Training mean: ' num2str(meandata.stat(1))])];
%     summary=[summary; cellstr('')];
% end

%% Test  15: mardiatestn_circ_equal, Test vs unrotated training
if rt(15)==1
    [H, pval, W, strPMethod] = mardiatestn_circ_equal([{ang2rad(testdata)} {ang2rad(traindata)}]);
    summary=[summary; cellstr('Mardia-Watson-Wheeler test for whether 2 samples are drawn from the same distribution(Mardia KV, 1972, "A multi-sample uniform scores test on a circle and its parametric competitor." J Royal Statistical Society B (Methodological) 34, 102-113):')];
    summary=[summary; cellstr(['W: ' num2str(W)])];
    if pval>0.0001
    summary=[summary; cellstr(['P: ' num2str(pval)])];
    else
      summary=[summary; cellstr('P < 0.0001')];  
    end
    if pval>0.05
    summary=[summary; cellstr(['CANNOT reject the hypothesis that training and test data are drawn from the same distribution, when aligned on ' cname])];
    else
    summary=[summary; cellstr(['Test and training data ARE NOT drawn from the same distribution, when aligned on ' cname])]; 
    end
    summary=[summary; cellstr('')];
end

 
%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Compare distribution to 0 (pattern-defined goal)
if any(rt([3;5; 14; 31; 33])==1)
    summary=[summary; cellstr('_ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _')];
    summary=[summary; cellstr(['Is test data significantly different to  ' pname '?'])];
    summary=[summary; cellstr('')];

    %Make fig to check rotation  as expected
figure; hold all; 
dd1=histogram(testdata,hbins.h); %Unrotated data, pale blue
% h = findobj(gca,'Type','patch');
    set(dd1, 'EdgeColor', [0.5 0.5 1]);
    set(dd1, 'FaceColor', [0.5 0.5 1]);
dd2=histogram(testdatarotated,hbins.h); %Rotated data, deep blue
% h = findobj(gca,'Type','patch');
    set(dd2, 'EdgeColor', [0 0 1]);
    set(dd2, 'FaceColor', [0 0 1]);
d1=scatter(patternmatch,0,[],'filled','d');% Unrotated patternmatch;
d1.CData=[0.5 0.5 1];
d2=scatter(0,0,[],'filled','d');% Rotated patternmatch, now at 0
d2.CData=[0 0 1];
% axis([xmin xmax ymin ymax]);
% set(gcf,'Position',figposition);
set(gca,'XDir','Reverse'); 

end

%%  Test 3: circ_medtest, H0=pattern-defined goal
%circ_medtest to compare median of observed distribution to the expected
%median if ants use pattern-defined goal
if rt(3)==1
    [pval] = circ_medtest(ang2rad(testdata),ang2rad(pgoal));
    summary=[summary; cellstr(['Binomial test (Zar JH, 1999, Biostatistical Analysis) to test whether circular median of observed distribution is different from ' pname ':'])];
    summary=[summary; cellstr(['N: ' num2str(length(testdata))])];
    if pval>0.0001
    summary=[summary; cellstr(['P: ' num2str(pval)])];
    else
      summary=[summary; cellstr(['P < 0.0001'])];  
    end
    if pval>0.05
    summary=[summary; cellstr(['NO significant difference between ' pname ' and circular median of observed facing directions.'])];
    else
    summary=[summary; cellstr(['Circular median of facing directions IS significantly different from ' pname])]; 
    end
    summary=[summary; cellstr('')];
end %if runtests(2, testtype+1)==1

%% Test 5: circ_mtest, H0=pattern-defined goal
%circ_mtest to compare mean of observed distribution to the expected
%mean if ants use pattern-defined goal
if rt(5)==1
    [h] = circ_mtest(ang2rad(testdata),ang2rad(pgoal));
    summary=[summary; cellstr(['M-Test (Zar JH, 1999, Biostatistical Analysis) to  test whether circular mean of observed distribution is different from ' pname])];
    summary=[summary; cellstr('NB, this test doesn''t return a P-value. I suspect significance is determined by whether the predicted mean falls within the 95% CI, which we have already calculated, above.')];
    summary=[summary; cellstr(['N: ' num2str(length(testdata))])];
    if h==0
    summary=[summary; cellstr('P > 0.05')];
    summary=[summary; cellstr(['NO significant difference between ' pname ' and circular mean of observed facing directions at 0.05 level.'])];
    else
    summary=[summary; cellstr('P < 0.05')];
    summary=[summary; cellstr(['Circular mean of facing directions IS significantly different from ' pname ' at 0.05 level.'])]; 
    end
    summary=[summary; cellstr('')];
end

%% Test 14: circ_vtest, H0=pattern goal
%circ_mtest to compare mean of observed distribution to the expected
%mean if ants use pattern-defined goal
if rt(14)==1
    [pval, v] = circ_vtest(ang2rad(testdata),ang2rad(pgoal));
    summary=[summary; cellstr(['V-Test (Zar JH, 1999, Biostatistical Analysis) to  test whether observed distribution is non-uniform with mean equal to'  pname ':'])];
    summary=[summary; cellstr(['N: ' num2str(length(testdata))])];
    summary=[summary; cellstr(['V: ' num2str(v)])];
    if pval>=0.0001 & pval<=0.9999
    summary=[summary; cellstr(['P: ' num2str(pval)])];
    elseif pval<0.0001
      summary=[summary; cellstr(['P < 0.0001'])];  
    elseif pval>0.9999
      summary=[summary; cellstr(['P > 0.999'])];   
    end
    if pval>0.05
    summary=[summary; cellstr(['Either distribution is UNIFORM or it is non-uniform with a mean significantly DIFFERENT to ' pname ])];
    else
    summary=[summary; cellstr(['Distribution IS non-uniform with mean equal to ' pname])]; 
    end
    summary=[summary; cellstr('')];
end

%% Test 31: Likelihood ratio test, H0=0
%Likelihood ratio test to compare mean of observed distribution to the expected
%mean if ants use pattern-defined goal
if rt(31)==1
    [pval, stat, df]=CircMeantTestJLW(ang2rad(testdata),ang2rad(pgoal), 'lr');
    summary=[summary; cellstr(['Likelihood ratio Test (Mardia & Jupp, 2000) to test whether mean of distribution differs from ' pname ':'])];
    summary=[summary; cellstr(['d.f.: ' num2str(df)])];
    summary=[summary; cellstr(['Chi-Sq: ' num2str(stat)])];
    if pval>=0.0001 & pval<=0.9999
    summary=[summary; cellstr(['P: ' num2str(pval)])];
    elseif pval<0.0001
      summary=[summary; cellstr(['P < 0.0001'])];  
    elseif pval>0.9999
      summary=[summary; cellstr(['P > 0.999'])];   
    end
    if pval>=0.05
    summary=[summary; cellstr(['NO significant difference between ' pname  ' and circular mean of observed facing directions.' ])];
    else
    summary=[summary; cellstr(['Circular mean of facing directions IS significantly different from ' pname ])]; 
    end
    summary=[summary; cellstr('')];
end

%% Test 33: Watson Williams mean test, H0=0
%Watson-Williams test to compare mean of observed distribution to the expected
%mean if ants use channel-defined goal
if rt(33)==1
    [pval, stat, df]=CircMeantTestJLW(ang2rad(testdata),ang2rad(pgoal), 'ww');
    summary=[summary; cellstr(['Watson-Williams mean Test (Mardia & Jupp, 2000) to test whether mean of distribution differs from ' pname ':'])];
    summary=[summary; cellstr(['d.f.: ' num2str(df)])];
    summary=[summary; cellstr(['F: ' num2str(stat)])];
    if pval>=0.0001 & pval<=0.9999
    summary=[summary; cellstr(['P: ' num2str(pval)])];
    elseif pval<0.0001
      summary=[summary; cellstr(['P < 0.0001'])];  
    elseif pval>0.9999
      summary=[summary; cellstr(['P > 0.999'])];   
    end
    if pval>=0.05
    summary=[summary; cellstr(['NO significant difference between ' pname  ' and circular mean of observed facing directions.' ])];
    else
    summary=[summary; cellstr(['Circular mean of facing directions IS significantly different from ' pname ])]; 
    end
    summary=[summary; cellstr('')];
end

%% Compare test to train distribution, aligned on pattern goal
if any(rt([7;9;12])==1)
    summary=[summary; cellstr('_ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _')];
    summary=[summary; cellstr(['Is test distribution significantly different from training distribution when aligned on ' pname '?'])];
    summary=[summary; cellstr('')];
   
    %Make fig to check rotation  as expected
figure; hold all; 
dd1=histogram(traindata,hbins.h); %Unrotated  training data, pale red
% h = findobj(gca,'Type','patch');
    set(dd1, 'EdgeColor', [1 0.5 0.5]);
    set(dd1, 'FaceColor', [1 0.5 0.5]);
dd2=histogram(testdatarotated,hbins.h); %Rotated data, deep blue
% h = findobj(gca,'Type','patch');
    set(dd2, 'EdgeColor', [0 0 1]);
    set(dd2, 'FaceColor', [0 0 1]);
d2=scatter(0,0,[],'filled','d');% Rotated patternmatch, now at 0
d2.CData=[0 0 1];
dm1=scatter(rad2ang(circ_median(ang2rad(testdatarotated))),0,[],'filled','d');% Median of rotated data;
dm1.CData=[0.5 1 0.5];
dm2=scatter(testmedianrotated,0,[],'filled','d');% Median of rotated data;
dm2.CData=[0 1 0];

% axis([xmin xmax ymin ymax]);
% set(gcf,'Position',figposition);
set(gca,'XDir','Reverse'); 



end

%% Test7: circ_cmtest, Test vs rotated training
if rt(7)==1
    [pval, med, P] = circ_cmtest(ang2rad(testdatarotated), ang2rad(traindata));
    summary=[summary; cellstr('Common median test (Fisher NI, 1995) to test for equal medians in two distributions (circular equivalent of Kruskal-Wallis test):')];
    summary=[summary; cellstr(['N: ' num2str(length(testdatarotated)) ', ' num2str(length(traindata))])];
    summary=[summary; cellstr(['Common median test statistic (P): ' num2str(P)])];
    if pval>0.0001
    summary=[summary; cellstr(['P: ' num2str(pval)])];
    else
      summary=[summary; cellstr('P < 0.0001')];  
    end
    if pval>0.05
    summary=[summary; cellstr(['NO significant difference between circular medians of training and test distribution, when aligned on ' pname])];
    summary=[summary; cellstr(['Estimated shared population median (relative to pattern-defined goal): ' num2str(rad2ang(med))])];
    else
    summary=[summary; cellstr(['Circular median of test distribution IS significantly different to that of training distribution, when aligned on ' pname])]; 
    summary=[summary; cellstr(['Test median (relative to ' pname '): ' num2str(testmedianrotated) '; Training median (relative to ' pname '): ' num2str(mediandata.stat(1))])];
    end
    summary=[summary; cellstr('')];
end

%% Test 9: circ_wwtest,  Test vs rotated training
if rt(9)==1
    [pval, table] = circ_wwtest(ang2rad(testdatarotated), ang2rad(traindata));
    summary=[summary; cellstr('Parametric Watson-Williams test (Zar JH, 1999, Biostatistical Analysis) to test for equal means in two distributions (circular equivalent of one-way ANOVA):')];
    summary=[summary; cellstr(['d.f.: ' num2str(table{2,2}) ', ' num2str(table{3,2})])];
    summary=[summary; cellstr(['F: ' num2str(table{2,5})])];
    if pval>0.0001
    summary=[summary; cellstr(['P: ' num2str(pval)])];
    else
      summary=[summary; cellstr('P < 0.0001')];  
    end
    if pval>0.05
    summary=[summary; cellstr(['NO significant difference between circular means of training and test distribution, when aligned on ' pname])];
    else
    summary=[summary; cellstr(['Circular mean of test distribution IS significantly different to that of training distribution, when aligned on ' pname])]; 
    end
    summary=[summary; cellstr(['Test mean (relative to ' pname '): ' num2str(testmeanrotated) '; Training mean (relative to ' pname '): ' num2str(meandata.stat(1))])];
    summary=[summary; cellstr('')];
    
end

%% Test 12: signrank, test data is difference between test and rotated training for paired data (1dp per ant), H0=0
if rt(12)==1 & perant==1
    alpha=angdiff(testdatarotated,traindata,'ang','directional');
    [pallintest,hallintest,statsallintest]=signrank(alpha);
    summary=[summary; cellstr(['Paired test: is difference between each ant''s median facing direction in tests vs training significantly different from zero, when aligned on ' pname '?'])];
    summary=[summary; cellstr('Data for testing is each ant''s median direction in the test minus the same ant''s median direction in training (after rotation to align patterns). If they behave the same in the test as they did during training (with respect to the pattern), this difference should be equal to zero.')];
    summary=[summary; cellstr('1-sample Wilcoxon signed rank test for zero median:')];
    summary=[summary; cellstr(['N: ' num2str(length(alpha))])];
    summary=[summary; cellstr(['Z: ' num2str(statsallintest.zval)])];
    if pallintest>0.0001
    summary=[summary; cellstr(['P: ' num2str(pallintest)])];
    else
      summary=[summary; cellstr(['P < 0.0001'])];  
    end
    if hallintest==0
    summary=[summary; cellstr(['NO significant difference between facing directions in test and training, when aligned on ' pname])];
    else
    summary=[summary; cellstr(['Facing directions ARE significantly different between test and training, when aligned on ' pname])]; 
    end
    summary=[summary; cellstr(['Median difference between treatments is: ' num2str(median(alpha)) ' degrees'])];
    summary=[summary; cellstr('')];
end

%% Test  16: mardiatestn_circ_equal, Test vs rotated training
if rt(16)==1
    [H, pval, W, strPMethod] = mardiatestn_circ_equal([{ang2rad(testdatarotated)} {ang2rad(traindata)}]);
    summary=[summary; cellstr('Mardia-Watson-Wheeler test for whether 2 samples are drawn from the same distribution(Mardia KV, 1972, "A multi-sample uniform scores test on a circle and its parametric competitor." J Royal Statistical Society B (Methodological) 34, 102-113):')];
    summary=[summary; cellstr(['W: ' num2str(W)])];
    if pval>0.0001
    summary=[summary; cellstr(['P: ' num2str(pval)])];
    else
      summary=[summary; cellstr('P < 0.0001')];  
    end
    if pval>0.05
    summary=[summary; cellstr(['CANNOT reject the hypothesis that training and test data are drawn from the same distribution, when aligned on ' pname])];
    else
    summary=[summary; cellstr(['Test and training data ARE NOT drawn from the same distribution, when aligned on ' pname])]; 
    end
    summary=[summary; cellstr('')];
end












%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Compare distribution of end-points to overall path headings
if any(rt([27;28;29;34;35])==1)
    discrepancy=angdiff(testdata, testheading,  'ang', 'directional');
    groupid=(100*testantid)+testheading;
     [~,~,groupid]=unique(groupid);

    meandiscrepancy=zeros(max(groupid),1);
    meantestdata=zeros(max(groupid),1);
    meantestheading=zeros(max(groupid),1);
        for gind=1:max(groupid)
            meandiscrepancy(gind)=rad2ang(circ_mean(ang2rad(discrepancy(groupid==gind))));
             meantestdata(gind)=rad2ang(circ_mean(ang2rad(testdata(groupid==gind))));
              meantestheading(gind)=rad2ang(circ_mean(ang2rad(testheading(groupid==gind))));
        end
    [meandisc(1), meandisc(2), meandisc(3), ~, ~]=bootstrapmean(discrepancy,10000,0.95); 
    [meanmdisc(1), meanmdisc(2), meanmdisc(3), ~, ~]=bootstrapmean(meandiscrepancy,10000,0.95); 

    
    summary=[summary; cellstr('_ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _')];
    summary=[summary; cellstr('Are end-points correlated with overall path headings?')];
    summary=[summary; cellstr('')];
    summary=[summary; cellstr(['Mean discrepancy between end-points and overall heading =  ' num2str(meandisc(1)) ';  96% CI = '  num2str(meandisc(2)) ' : '  num2str(meandisc(3))])];
    summary=[summary; cellstr(['Mean discrepancy between the mean of all end-points in each path and overall heading =  ' num2str(meanmdisc(1)) ';  96% CI = '  num2str(meanmdisc(2)) ' : '  num2str(meanmdisc(3))])];
    summary=[summary; cellstr('')];
end

%% Test 27: circ_corrcc, discrepancy vs 0
if rt(27)==1 & datatype>1
    [rho, pval] = circ_corrcc(ang2rad(testdata), ang2rad(testheading));
    summary=[summary; cellstr('Circular correlation coefficient (Jammalamadaka and Sengupta, 2001, Topics in Circular Statistics. World Scientific. p. 176) to test whether end-points of turns are correlated with the overall path directions:')];
    summary=[summary; cellstr(['N: ' num2str(length(testdata))])];
    summary=[summary; cellstr(['Rho (circular correlation coefficient: ' num2str(rho)])];
    if pval>=0.0001 & pval<=0.9999
    summary=[summary; cellstr(['P: ' num2str(pval)])];
    elseif pval<0.0001
      summary=[summary; cellstr(['P < 0.0001'])];  
    elseif pval>0.9999
      summary=[summary; cellstr(['P > 0.999'])];   
    end
    if pval>0.05
    summary=[summary; cellstr('NO significant correlation between turn end-points and path headings.')];
    else
    summary=[summary; cellstr('Turn end-points ARE signficantly correlated with the overall heading of each path.')]; 
    end
    summary=[summary; cellstr('')];
    
    [rho, pval] = circ_corrcc(ang2rad(meantestdata), ang2rad(meantestheading));
    summary=[summary; cellstr('Circular correlation coefficient (Jammalamadaka and Sengupta, 2001, Topics in Circular Statistics. World Scientific. p. 176) to test whether mean end-point of all turns in each path are correlated with the overall path direction:')];
    summary=[summary; cellstr(['N: ' num2str(length(testdata))])];
    summary=[summary; cellstr(['Rho (circular correlation coefficient: ' num2str(rho)])];
    if pval>=0.0001 & pval<=0.9999
    summary=[summary; cellstr(['P: ' num2str(pval)])];
    elseif pval<0.0001
      summary=[summary; cellstr(['P < 0.0001'])];  
    elseif pval>0.9999
      summary=[summary; cellstr(['P > 0.999'])];   
    end
    if pval>0.05
    summary=[summary; cellstr('NO significant correlation between mean turn end-points and path headings.')];
    else
    summary=[summary; cellstr('The mean end-point of all tuns in each path IS signficantly correlated with the overall heading of each path.')]; 
    end
    summary=[summary; cellstr('')];  
    
end  
%% Test 28: circ_mtest, discrepancy vs 0
%circ_mtest to compare discrepancy between edn-points and path headings to
%zero

if rt(28)==1 & datatype>1
    [h] = circ_mtest(ang2rad(discrepancy),0);
    summary=[summary; cellstr('M-Test (Zar JH, 1999, Biostatistical Analysis) to  test whether discrepancy between all end-points and overall path headings is different from 0  (i.e. whether the end-points are different from the path headings):')];
    summary=[summary; cellstr('NB, this test doesn''t return a P-value. I suspect significance is determined by whether the predicted mean falls within the 95% CI, which we have already calculated, above.')];
    summary=[summary; cellstr(['N: ' num2str(length(discrepancy))])];
    if h==0
    summary=[summary; cellstr('P > 0.05')];
    summary=[summary; cellstr('NO significant difference between end-points and path  headings at 0.05 level.')];
    else
    summary=[summary; cellstr('P < 0.05')];
    summary=[summary; cellstr('End-points ARE significantly different from path headings at 0.05 level.')]; 
    end
    summary=[summary; cellstr('')];
    
    [h] = circ_mtest(ang2rad(meandiscrepancy),0);
    summary=[summary; cellstr('M-Test (Zar JH, 1999, Biostatistical Analysis) to  test whether discrepancy between the mean end-point wirhin each path and the path heading is different from 0  (i.e. whether the mean end-points are different from the path headings):')];
    summary=[summary; cellstr('NB, this test doesn''t return a P-value. I suspect significance is determined by whether the predicted mean falls within the 95% CI, which we have already calculated, above.')];
    summary=[summary; cellstr(['N: ' num2str(length(meandiscrepancy))])];
    if h==0
    summary=[summary; cellstr('P > 0.05')];
    summary=[summary; cellstr('NO significant difference between mean end-points and path  headings at 0.05 level.')];
    else
    summary=[summary; cellstr('P < 0.05')];
    summary=[summary; cellstr('Mean end-points ARE significantly different from path headings at 0.05 level.')]; 
    end
    summary=[summary; cellstr('')];
end

%% Test 29: circ_vtest, H0=pattern goal
%circ_mtest to compare mean of observed distribution to the expected
%mean if ants use pattern-defined goal
if rt(29)==1 & datatype>1
    [pval, v] = circ_vtest(ang2rad(discrepancy),0);
    summary=[summary; cellstr('V-Test (Zar JH, 1999, Biostatistical Analysis) to  test whether distribution  of discrepancy between each end-point in a path and the overall path heading is non-uniform with mean equal to 0 (i.e. whether the end-points are different from the path headings):')];
    summary=[summary; cellstr(['N: ' num2str(length(discrepancy))])];
    summary=[summary; cellstr(['V: ' num2str(v)])];
    if pval>=0.0001 & pval<=0.9999
    summary=[summary; cellstr(['P: ' num2str(pval)])];
    elseif pval<0.0001
      summary=[summary; cellstr(['P < 0.0001'])];  
    elseif pval>0.9999
      summary=[summary; cellstr(['P > 0.999'])];   
    end
    if pval>0.05
    summary=[summary; cellstr('Either distribution is UNIFORM or it is non-uniform with a mean significantly DIFFERENT to 0 (NO evidence that end-points are aligned with overall path headings).')];
    else
    summary=[summary; cellstr('Distribution IS non-uniform with mean equal to 0. (End-points ARE  aligned with overall path headings)')]; 
    end
    summary=[summary; cellstr('')];
    
    [pval, v] = circ_vtest(ang2rad(meandiscrepancy),0);
    summary=[summary; cellstr('V-Test (Zar JH, 1999, Biostatistical Analysis) to  test whether distribution of discrepancy between mean end-point of each path and the path heading is non-uniform with mean equal to 0 (i.e. whether the mean end-points are different from the path headings):')];
    summary=[summary; cellstr(['N: ' num2str(length(meandiscrepancy))])];
    summary=[summary; cellstr(['V: ' num2str(v)])];
    if pval>=0.0001 & pval<=0.9999
    summary=[summary; cellstr(['P: ' num2str(pval)])];
    elseif pval<0.0001
      summary=[summary; cellstr(['P < 0.0001'])];  
    elseif pval>0.9999
      summary=[summary; cellstr(['P > 0.999'])];   
    end
    if pval>0.05
    summary=[summary; cellstr('Either distribution is UNIFORM or it is non-uniform with a mean significantly DIFFERENT to 0 (NO evidence that mean end-points are aligned with overall path headings).')];
    else
    summary=[summary; cellstr('Distribution IS non-uniform with mean equal to 0. (Mean end-points ARE  aligned with overall path headings)')]; 
    end
    summary=[summary; cellstr('')];
    
end

%% Test 34: Likelihood ratio test, H0=0
%Likelihood ratio test, discrepancy vs 0
%compare discrepancy between end-points and path headings to
%zero
if rt(34)==1
    [pval, stat, df]=CircMeantTestJLW(ang2rad(discrepancy),0, 'lr');
    summary=[summary; cellstr(['Likelihood ratio Test (Mardia & Jupp, 2000) to  test whether discrepancy between all end-points and overall path headings is different from 0  (i.e. whether the end-points are different from the path headings):'])];
    summary=[summary; cellstr(['d.f.: ' num2str(df)])];
    summary=[summary; cellstr(['Chi-Sq: ' num2str(stat)])];
    if pval>=0.0001 & pval<=0.9999
    summary=[summary; cellstr(['P: ' num2str(pval)])];
    elseif pval<0.0001
      summary=[summary; cellstr(['P < 0.0001'])];  
    elseif pval>0.9999
      summary=[summary; cellstr(['P > 0.999'])];   
    end
    if pval>=0.05
    summary=[summary; cellstr(['Endpoints NOT significantly different to path headings.' ])];
    else
    summary=[summary; cellstr(['Endpoints ARE signficantly different to path headings'])]; 
    end
    summary=[summary; cellstr('')];
end

%% Test 35: Watson Williams mean test, H0=0
%Watson-Williams test to compare mean of observed distribution to the expected
%mean if ants use channel-defined goal
if rt(35)==1
    [pval, stat, df]=CircMeantTestJLW(ang2rad(discrepancy),0, 'ww');
    summary=[summary; cellstr(['Watson-Williams mean Test (Mardia & Jupp, 2000)to  test whether discrepancy between all end-points and overall path headings is different from 0  (i.e. whether the end-points are different from the path headings):'])];
    summary=[summary; cellstr(['d.f.: ' num2str(df)])];
    summary=[summary; cellstr(['F: ' num2str(stat)])];
    if pval>=0.0001 & pval<=0.9999
    summary=[summary; cellstr(['P: ' num2str(pval)])];
    elseif pval<0.0001
      summary=[summary; cellstr(['P < 0.0001'])];  
    elseif pval>0.9999
      summary=[summary; cellstr(['P > 0.999'])];   
    end
    if pval>=0.05
    summary=[summary; cellstr(['Endpoints NOT significantly different to path headings.' ])];
    else
    summary=[summary; cellstr(['Endpoints ARE signficantly different to path headings'])]; 
    end
    summary=[summary; cellstr('')];
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Compare dispersion of headings; sinuosity; etc
%% Test 10: circ_ktest, test vs unrotated training
if rt(10)==1
    [pval, f] = circ_ktest(ang2rad(testdata), ang2rad(traindata));
    summary=[summary; cellstr('_ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _')];
    summary=[summary; cellstr('Is the concentration parameter of the test distribution significantly different from that of the training distribution?')];
    summary=[summary; cellstr('If the test is significant, the facing directions were more spread out in one treatment than the other.')];
    summary=[summary; cellstr('Two-sample K-test for equal concentration parameters (Batschelet, 1980, section 6.9, pg 122-124):')];
    summary=[summary; cellstr(['N: ' num2str(length(testdata)) ', ' num2str(length(traindata))])];
    summary=[summary; cellstr(['F: ' num2str(f)])];

    if pval>0.0001
    summary=[summary; cellstr(['P: ' num2str(pval)])];
    else
      summary=[summary; cellstr('P < 0.0001')];  
    end
    if pval>0.05
    summary=[summary; cellstr('NO significant difference between concentration parameters for training and test distribution.')];
    else
    summary=[summary; cellstr('Concentration parameter of test distribution IS significantly different to that of training distribution.')]; 
    end
    summary=[summary; cellstr('')];

end

%% Test 17: Two-sample t-test, Compare sinuosity test vs training
if rt(17)==1 & datatype==1 %Only makes sense to compare sinuosity between paths
    [H,pval,CI,STATS] = ttest2(asin(sqrt(testsinuosity)), asin(sqrt(trainsinuosity)));
    summary=[summary; cellstr('_ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _')];
    summary=[summary; cellstr('Compare the sinuosity of paths in the training vs test data')];
    summary=[summary; cellstr('Two-sample t-test for equal means')];
    summary=[summary; cellstr(['t: ' num2str(STATS.tstat)])];
    summary=[summary; cellstr(['d.f: ' num2str(STATS.df)])];
    if pval>0.0001
    summary=[summary; cellstr(['P: ' num2str(pval)])];
    else
      summary=[summary; cellstr('P < 0.0001')];  
    end
    if pval>0.05
    summary=[summary; cellstr('NO significant difference in sinuosity of paths in training and test distribution.')];
    else
    summary=[summary; cellstr('Sinuosity of test paths IS significantly different to those during training.')]; 
    end
    summary=[summary; cellstr(['Mean sinuosity of test paths = ' num2str(nanmean(testsinuosity))])]; 
    summary=[summary; cellstr(['Mean sinuosity of training paths = ' num2str(nanmean(trainsinuosity))])]; 
%         CIadj=(sin(CI)).^2;
%     summary=[summary; cellstr(['95% CI for the DIFFERENCE in means = ' num2str(min(CIadj)) ' : ' num2str(max(CIadj))])]; 

    summary=[summary; cellstr('')];

end

%% Test 18: paired t-test, Compare sinuosity test vs training, on an ant-by-ant basis
if rt(18)==1 & datatype==1 %Only makes sense to compare sinuosity between paths
    summary=[summary; cellstr('Compare the sinuosity of paths in the training vs test data')];
%     [H,pval,CI,STATS] = ttest(log10(patestsinuosity), log10(patrainsinuosity)); %IF sinuosity is a resultant vector length
%     [H,pval,CI,STATS] = ttest(log10(patestsinuosity), log10(patrainsinuosity)); %IF sinuosity is a ratio, arguable a log scale is more accurate
    [H,pval,CI,STATS] = ttest(patestsinuosity, patrainsinuosity);

    summary=[summary; cellstr('Paired t-test for equal means')];
    summary=[summary; cellstr('Data are the mean sinuosity of all paths by each individual ant that was used in both training and the test')];
    summary=[summary; cellstr(['t: ' num2str(STATS.tstat)])];
    summary=[summary; cellstr(['d.f: ' num2str(STATS.df)])];

    if pval>0.0001
    summary=[summary; cellstr(['P: ' num2str(pval)])];
    else
      summary=[summary; cellstr('P < 0.0001')];  
    end
    if pval>0.05
    summary=[summary; cellstr('NO significant difference in sinuosity of paths in training and test distribution.')];
    else
    summary=[summary; cellstr('Sinuosity of test paths IS significantly different to those during training.')]; 
    end
    summary=[summary; cellstr(['Mean sinuosity of test paths = ' num2str(nanmean(patestsinuosity))])]; 
    summary=[summary; cellstr(['Mean sinuosity of training paths = ' num2str(nanmean(patrainsinuosity))])]; 
    summary=[summary; cellstr('')];

    summary=[summary; cellstr('')];
end

%% Print summary
disp(char(summary));


% disp(namelist{dataselectind});
% eval([namelist{dataselectind} '=testdata;']);